; ---------------------------------------------------------------------------
;       Title - DanDemo.sc
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;  Chronology - Created: 07/04/90 12:32pm    Revised: 09/29/90 11:51pm
; Description - Start Up Script for Dan's Utility Demo.  Note that the
;               autolib value is passed as a formal parameter to MainMenu.u
;               procedure.  This allows you to change the autolib easily
;               without having to recompile the procedures that use it.
; ---------------------------------------------------------------------------
Echo OFF                               ; Clean up
Clear Reset
Release VARS All
Release PROCS All

PROC DDemo.u()
   Cursor OFF                             ; You should turn cursor off unless
                                          ;   doing an ACCEPT, etc.
   mem.n   = MemLeft()
   autolib = "pal\\Utility,pal\\DDemo"    ; Assign autolib for this app
   color.l = (Monitor() = "Color")        ; Necessary for Message/MenuPop2

   View "D\\Ddemocfg"
   IF color.l THEN
      PickForm 1
   ELSE
      PickForm 8
   ENDIF

   MoveTo [X]
   Echo NORMAL
   Echo OFF

   IF mem.n < 100000 THEN             ; In case resources are limited
      Message.u("MemLeft() = " +StrVal(mem.n)+ " - DropDown Menus May be Slow",3,1)
   ELSE
      Message.u("MemLeft() = " +StrVal(mem.n)+ " - Please Select Menu Style",1,1)
   ENDIF

   MenuPop2.l(2,26,"Select Menu System","DROPDOWN","SHOWMENU",
            "Quattro Style","Paradox Style",79,78,30,true)
   IF retval THEN
      PopBox.u(15,"We will be using the DROPDOWN Menu System",2,79,2)
      ClearAll
      DemoMainMenu.u(autolib,             ; Pass autolib to Closed Procedure
                     mem.n,               ; Startup MemLeft
                     1000000,             ; Minimum Diskspace in Private Dir
                    "d\\ddemocfg",        ; Main Menu configuration table
                    "pal\\Utility")       ; Library for ErrorProc
   ELSE
      PopBox.u(15,"We will be using the SHOWMENU Menu System",2,79,2)
      ClearAll
      ShowMainMenu.u(autolib,mem.n,100000,"d\\ddemocfg","pal\\Utility")
   ENDIF
ENDPROC

DDemo.u()
Release PROCS ALL                      ; Clean up again
Release VARS ALL
Clearall Reset
;endscript