? " DemoHelp.sc"                       ; Application Help Script
@ Row(),13 ?? Fill("",9)
@ Row(),13
libname.a = "DDemo"
IF not IsFile(libname.a + ".Lib") then
    Createlib libname.a SIZE 60
ENDIF
; ---------------------------------------------------------------------------
;       Title - CustomHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 12/06/90 12:10pm
; Description - This is the Description of the Application, which is used
;               as a default Help Screen, or when Application-specific help
;               is selected from the Help Menu.
; ---------------------------------------------------------------------------
PROC CustomHelp.u()
Private appmenu.a

Text
               Help on Using the Client Information Program    
            
                   Here are some statistics about your System
  








  
             
                      Dan's Utility Demonstration Program
                         Copyright (c) 1991
            
                     dp Solutions, Inc.
                         19 South Bridgeboro Street
                       Delran, New Jersey  08075-1831
                            (609) 461-5103
                  Daniel J. Paolini II - Patricia B. Paolini
             
EndText
; These are some system stats - sometimes of interest, sometimes necessary
    @  6,17 ?? "            Your Paradox Version is: ", Version()
    @  7,17 ?? "         Your Sort Order Setting is: ", SortOrder()
    @  8,17 ?? "        Your Query Order Setting is: ", QueryOrder()
    @  9,17 ?? "      Your Blanks = Zero Setting is: ", IsBlankZero()
    @ 10,17 ?? "    The Startup Memory (MemLeft) is: ", mem.n
    @ 11,17 ?? "  The Available Memory (MemLeft) is: ", MemLeft()
    @ 12,17 ?? "The Current Directory DriveSpace is: ", DriveSpace(SubStr(Directory(),1,1))
IF NOT IsBlank(PrivDir()) THEN          ; need to know if there's a Private Dir
    @ 13,17 ?? "The Private Directory DriveSpace is: ", DriveSpace(SubStr(PrivDir(),1,1))
ENDIF
PaintHelp.u()

WHILE true
    SHOWMENU
        "RETURN"    : "Return to where You were before HELP",
        "HELPMENU"  : "Return to the Previous Help Menu",
        "TREE"      : "View a Menu Tree for this Application",
        "LOCATE"    : "Help on Using the LOCATE Menu",
        "SELECT"    : "Help on Using the SELECT Routines",
        "GET_INPUT" : "Help on Using the GET_INFO Routines",
        "PRINTING"  : "Help on Using the PRINTING Routines",
        "ERROR"     : "Help on Using the Error Procedure",
        "VARIOUS"   : "Help on Using the VARIOUS Routines",
        "QBF"       : "Help on Using the Query By Form technique",
        "PBE"       : "What the Heck is Pal by Example Notation?",
        "DANGER"    : "Why You should always Read Code before Running it"
    To appmenu.a

    IF NOT retval OR appmenu.a = "RETURN" OR appmenu.a = "HELPMENU" THEN
        quit.l = NOT (appmenu.a = "HELPMENU")
        Return
    ENDIF

    @ 2,0
    Canvas OFF                          ; hide the elves work
    PaintCanvas FILL " " ATTRIBUTE 112 2,0,24,79
    ExecProc appmenu.a + "Help.u"
ENDWHILE
ENDPROC

WriteLib libname.a CustomHelp.u
Release PROCS CustomHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - TreeHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 10/01/90 00:20:49am    Revised:
; Description -
; ---------------------------------------------------------------------------
PROC TreeHelp.u()

Text
                           Dan's Demo Menu Tree                
            
  LOCATESELECTGET_INPUTPRINTINGVARIOUSQUIT Ŀ
                          Ŀ                      Ŀ                 
          FORMPICK               FILE                   YESĳ
                                                                      
               INSERTPICK             OUTPUT                 NO
                                                     
               ARRAYPICK              CHKPRINTER   
                                                     
               POPUPFORM              RESTART      
                                                   
                                                     
                            ACCEPT                  LISTING
                                                     
                            VALIDATE                ERROR
                                                     
                            QBFORM                  PACK
                                                      
                                                      RECOVER
                                                      
                                                      OTHERS

EndText
   PaintHelp.u()
   PaintCanvas ATTRIBUTE  31  4, 1, 4,71 ; Main Menu Bar, white on blue
   PaintCanvas ATTRIBUTE 113  5, 0,24,79 ; Tree, blue on grey
ENDPROC
WriteLib libname.a TreeHelp.u
Release PROCS TreeHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - LocateHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 09/13/90 12:07pm
; Description - Help for the Locate selection on the Main Menu
; ---------------------------------------------------------------------------
PROC LocateHelp.u()

Text
                      Help on Using the Locate Choice          
            

 *  The Locate Menu is a special menu that allows the user to specify the
    manner in which a search for a value should take place.

 *  You cannot search on the Record Number field (first column in tableview),
    or if the table has one or no records.

 *  The Incremental Search is useful on keyed fields.

 *  I'm very proud of the Fuzzy Search routine, yet no one else seems to be
    impressed!  Try searching on a value that isn't an exact match.

 *  The Ad Hoc Scan still has a few bugs.  Should be ready next time!


EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a LocateHelp.u
Release PROCS LocateHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - SelectHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 09/13/90 12:07pm
; Description - Help for the Select selection on the Main Menu
; ---------------------------------------------------------------------------
PROC SelectHelp.u()

Text
                      Help on Using the Select Choice          
            

 *  This presents four ways of selecting records for processing.

 *  The first two methods show the data in a Multi-record form, and allow
    the user to scroll to and pick a record.  The second version allows the
    adding of a new record on the fly.  The advantage to making the user
    select a record from an existing table is that you eliminate typos and
    inaccuracies versus asking the user to enter a value for which to search.

 *  The third way uses a Popup array-based window, similar to the incremental
    search routine.  You cannot add a new Lookup value.

 *  The last way uses a "popup" form from the second page of the form from
    which to select values.  A new value can be added on the fly

EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a SelectHelp.u
Release PROCS SelectHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - Get_InputHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 09/13/90 12:07pm
; Description - Help for the Get_Input selection on the Main Menu
; ---------------------------------------------------------------------------
PROC Get_InputHelp.u()

Text
                    Help on Using the GET_INPUT Choice         
            

 *  This demonstrates several ways to get input from a user.  A consistant
    application should always ask for information in the same ways.

 *  The first procedure demonstrates the GetInput.v procedure, without any
    data validation.  You will be asked to enter a date.

 *  The second procedure demonstrates the GetInput.v procedure, with data
    validation.  In this case, you are also asked to enter a date, but a
    default date has been pre-loaded into the acceptance field.

 *  The third procedure may be the most interesting.  It is a small-scale
    demonstration of the Query By Form technique promoted by Dan Erhmann.
    Additional information is available under the {QBF} menu choice on the
    Application Help menu.
EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a Get_InputHelp.u
Release PROCS Get_InputHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - PrintingHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 09/13/90 12:07pm
; Description - Help for the Printing selection on the Main Menu
; ---------------------------------------------------------------------------
PROC PrintingHelp.u()

Text
                     Help on Using the PRINTING Choice         
            

 *  This Selection demonstrates several routines related to Printing.

 *  The first Routine outputs a Report to a File, and then shows it on the
    screen using README.com.  This is much better than Paradox's {SCREEN}.

 *  The Second Routine presents an Output Selection Menu, from which you can
    send a Report to the Default Printer, the Screen, a File, or to a Selected
    Override Printer Port.

 *  The third Routine demonstrates a Check Printer Routine that can be called
    explicitly, or through the Error procedure.

 *  The last Routine demonstrates being able to Restart a report that has been
    Output to a DOS File, from a Selected Page.

EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a PrintingHelp.u
Release PROCS PrintingHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - VariousHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 09/13/90 12:04pm
; Description - Help for the Various selection on the Main Menu
; ---------------------------------------------------------------------------
PROC VariousHelp.u()

Text
                     Help on Using the VARIOUS Choice          
            

 *  This Selection demonstrates several different Utility procedures that are
    helpful, but not particularly impressive when viewed at application speed.
              (Actually, they just aren't very impressive, period.)

 *  You will first be given a menu from which to select the viewing speed:
        * NO_DELAY  This is the same as normal application speed (Echo OFF)
        * FAST      This is to view at Echo NORMAL speed
        * MEDIUM    This is to view at Echo FAST speed (not as fast as NORMAL)
        * SLOW      This is to view at Echo SLOW speed (recommended)

 *  The following procedures will then be demonstrated:
        * Message.u       - Generic message display on top of screen
        * CreateTable.l   - Creates a table like existing table
        * CancelSession.l - Do you want to Cancel an Edit session?
        * DeleteTable.u   - Deletes a table if it exists
        * NoAnswer.l      - Was a non-empty Answer table located?
        * NotDone.u       - Displays the lazy developers cop-out message
        * PopBox.u        - Special Effects pop up message box

EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a VariousHelp.u
Release PROCS VariousHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - ErrorHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No value
;  Chronology - Created: 09/13/90 12:06pm
; Description - Help for the Error selection on the Main Menu
; ---------------------------------------------------------------------------
PROC ErrorHelp.u()

Text
                      Help on Using an Error Procedure         
            

 *  I use Alan Zenreich's approach to Error handling.  There are two procs.
    The main errorproc is ErrorHandler.n, which is a variation of OopsPrint.
    This procedure handles a few housekeeping chores and advises the user
    when an error occurs.

 *  Assuming memory is available to load another procedure, ErrorHandler.n
    then calls ErrorLog.u, which creates a disk and printed log of the error
    condition and current environment.  In general practice using Relative
    Directory Addressing, I write this information (including a renamed
    SaveVars script) to an ERR sub-directory to keep the error logs out of
    the application directory.

 *  The ErrorHandler.n procedure then returns to where the error occurred and
    attempts to continue.  This is not necessarily a good practice in your
    application, because you can get trapped in a loop.  You should adjust the
    value returned by ErrorHandler.n to be "1" if you believe you can continue
    or "2" if you want to end the application at that point.  You should also
    password-protect your application start-up script so that if the program
    aborts, the user is exited from the application.
EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a ErrorHelp.u
Release PROCS ErrorHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - QBFHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 09/13/90 12:09pm
; Description - Help on Using the Query By Form section
; ---------------------------------------------------------------------------
PROC QBFHelp.u()

Text
                        Help on Using Query By Form            
            

 *  One of Paradox's strong suits is it's interactive Query By Example.  QBE,
    unfortunately, is not easily implemented within an application.  Query By
    Form solves some of the problems associated with trying to allow the user
    to perform Ad Hoc queries within an application.

 *  The traditional approach, used by PPROG, is to try and anticipate all of
    the possible ways that users might want to see information, and create
    the necessary queries using variables for user input.  Invariably, as
    soon as the application is running, users start asking for more queries.

 *  Another method places the user on the Query Table, in a Wait TABLE.  The
    user creates the query on the fly.  The disadvantages are:  if the user
    does not check all fields, the answer won't match the report table; the
    user can issue CHANGETO's and DELETE's and modify data in an uncontrolled
    manner; and, it will not work under RunTime.

 *  QBF addresses these concerns by, in effect, accepting variables for all of
    the fields of the query (or those you allow) without allowing the damaging
    operations.  It allows you set up a nice entry form to capture the data,
    and it works with RunTime.  It insures that all fields remain Check'ed.
EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a QBFHelp.u
Release PROCS QBFHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - PBEHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value
;  Chronology - Created: 09/14/90 09:28pm
; Description - Help on Understanding my Coding Notation
; ---------------------------------------------------------------------------
PROC PBEHelp.u()

Text
                 What the Heck is Pal By Example Notation?     
            
              Ŀ
                 From Alan Zenreich and Jim Kocis, Authors of:   
                The Paradox Programmer's Guide - Pal By Example  
                          Paraphrased with Permission            
              
 *  Variables and procedure names MUST NOT duplicate Paradox reserved words,
    but we have no way of knowing what future words will be reserved.
 *  Charles Simonyi, in "Programmers at Work", suggests that to improve the
    readability of programs, you should pay attention to how you name things,
    and make the names help describe what is happening within the program.
 *  If a standard form of notation was adopted by programmers, it would be
    much easier to pick up a piece of code and follow what is happening.
 *  After much research, Alan and Jim proposed that variables and functions
    be given a suffix consisting of a period and a letter.  The letter will
    described the type of value represented or returned, and the period will
    eliminate conflicts with reserved words.  The suffixes are:
       .a - alphanumeric  .l - logical        .r - array
       .n - numeric       .c - currency       .v - variable
       .d - date          .s - short integer  .u - unchanged (none returned)
 *  I urge that you consider adopting this standard within your programs, and
    I thank the authors for their efforts in promulgating it.
EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a PBEHelp.u
Release PROCS PBEHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - DangerHelp.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns - No Value and Serves No Value
;  Chronology - Created: 09/14/90 10:07:19pm    Revised: 09/30/90 00:35am
; Description - A Nasty Trick - not for the faint of heart (the lawyers made
;               me say that).
; ---------------------------------------------------------------------------
PROC DangerHelp.u()
Private  n                             ; Loop counter
   Canvas ON
   Beep Sleep 250 Beep Sleep 250 Beep
   Style ATTRIBUTE SysColor(3)
   @ 24,0 ?? Format("w80,ar","Unexpected condition: Drive C requires formatting -- Leaving Paradox")
   Sleep 3000
   PaintCanvas ATTRIBUTE 15 0,0,24,79
   Sleep 2000
   Style ATTRIBUTE 15
   @ 0,0 ?? "C:\\>Formatting Drive C:"
   FOR n FROM 1 TO 100
      @ 2,0 ?? Format("w4,ar",n) + " percent of disk formatted"
      Print FILE "nasty.sc" "This is a nasty trick!"
      Sleep 100
   ENDFOR
   @ 4,0 ?? "C:\\>Format complete"
   Print FILE "nasty.sc" "This is a nasty trick!"
   Run BIG NOREFRESH "Del Nasty.sc > NUL"
   Run BIG NOREFRESH "Dir > NUL"
   @ 6,0 ?? "  33314816 bytes total disk space"
         ? "  33314774 bytes in bad sectors"
         ? "        42 bytes available on disk"
         ? ""
         Sleep 3000
         ? "    655360 total bytes memory"
         ? "    172173 bytes free"
   Sleep 2000
   PopBox.u(15,"If you haven't figured it out yet - Nothing happened <g>",1,SysColor(3),5)
   Style
   Clear
   Text
                         Well?...  What did you think?           
               
   EndText
   PaintHelp.u()
ENDPROC
WriteLib libname.a DangerHelp.u
Release PROCS DangerHelp.u
?? ""
