? " DemoMenu.sc"                       ; PullDown and ShowMenu Script
@ Row(),13 ?? Fill("",13)
@ Row(),13
libname.a = "DDemo"
IF not IsFile(libname.a + ".Lib") then
    Createlib libname.a SIZE 60
ENDIF
; ===========================================================================
;       TITLE: DemoMainMenu.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-25-91 08:35:52pm     Last Revised: 01-27-91 08:19pm
;     RETURNS: No Value
; DESCRIPTION: Application Setup proc for MainMenu.l - Sets variables.
; ---------------------------------------------------------------------------
PROC CLOSED DemoMainMenu.u(autolib,mem.n,disk.n,cfgtable.a,errorlib.a)
   proc.a = "DemoMainMenu.u"              ; Name of procedure
   ReadLib errorlib.a ErrorHandler.n
   errorproc = "ErrorHandler.n"
   IF Version() < 3 THEN                   ; check version
      PopBox.u(10,"Sorry, you need Paradox 3.# for this Demo",0,SysColor(3),3)
      QUIT "Paradox 3.5 is well worth the upgrade investment"
   ENDIF
   Startup.l()
   IF NOT retval THEN
      Return
   ENDIF
;   PrinterSetupProc.u()
   elite.a     = "\027\019\027\29"        ; Elite printer control string
   pica.a      = "\027\019\027\018"       ; Pica printer control string
   condensed.a = "\027\020"               ; Condensed printer control string
   port.a      = "PRN"                    ; Default printer port
   Array mainmenu.r[6]                    ; Setup Array of Main Menu Choices
      mainmenu.r[1] = "LOCATE"
      mainmenu.r[2] = "SELECT"
      mainmenu.r[3] = "GET_INPUT"
      mainmenu.r[4] = "PRINTING"
      mainmenu.r[5] = "VARIOUS"
      mainmenu.r[6] = "QUIT"
; This next section uses a technique that I picked up from WaitPlus by Alan
;     Zenreich and Jim Kocis.  The calls to DropMenu.u and each Main Menu
;     choice in the mainmenu.r Array are made to place the procedures into
;     memory.  The proc sees that item.n = 0 and immediately returns.
;     At the same time, the FOR loop builds the second line Menu prompt for
;     when a Dropdown is displayed.
   item.n = 0
   MenuPull.u(0,0,0)                   ; Call MenuPull.u into memory
   ExecProc "Main" +mainmenu.r[1]+ ".u"   ; Call Menu Choice 1 into memory
   prompt.a = "   " + mainmenu.r[1]         ; Start concatonating Prompt Line 1
   IF NOT ArraySize(mainmenu.r) = 1 THEN  ; Just in case!
      FOR n From 2 To ArraySize(mainmenu.r)
         prompt.a = prompt.a +"  " +mainmenu.r[n]   ; Add to Prompt line
         ExecProc "Main" +mainmenu.r[n]+ ".u"         ; Call into memory
      ENDFOR
      IF Len(prompt.a) > 77 THEN          ; Just in Case!
         PopBox.u(10,"Sorry, the Main Menu prompt is too long",2,SysColor(3),3)
         Return
      ENDIF
   ENDIF

   prompt.a = prompt.a + Spaces(80 - Len(prompt.a))   ; Fill out with spaces
   ; Asc(255) is used to initialize Hotkeys, Hotprocs initialized to Blank
   Array hotkey.r[3]                      ; Setup Array of Menu Hot Keys
      hotkey.r[1] = 2
      hotkey.r[2] = 255
      hotkey.r[3] = 255
   Array hotproc.r[3]                     ; Setup Array of Hot Key Procs
      hotproc.r[1] = "BoxDemo.u"
      hotproc.r[2] = ""
      hotproc.r[3] = ""
   MainMenu.l(ArraySize(mainmenu.r),
              79,                         ; Status Line attribute
              63,                         ; Highlighted Menu Bar attribute
              49,                         ; Lowlighted Menu Bar attribute
              31)                         ; Cursor attribute
   IF retval THEN
      ; Add Departure Routines here
      ClosingCredits.u()
   ENDIF
   Clear ClearAll
   Return
ENDPROC
WriteLib libname.a DemoMainMenu.u
Release PROCS      DemoMainMenu.u
?? ""
; ===========================================================================
;       TITLE: MainLocate.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 03:43:04pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MainLocate.u()
Private  item.r,                       ; Array of Dropdown Menu Items
         proc.a                        ; Name of current procedure
;Global  execproc.a                    ; Name of Proc to call
;        loop.l                        ; Continue in DropDowns?
   proc.a = "MainLocate.u"
   IF item.n = 0 THEN     ; Then Just reading into Memory
      Return
   ENDIF
   IF key.n > 0 THEN                   ; IF key.n = 0 THEN we got here because
      execproc.a = "LocateDemo.u"      ;  the user pressed left/right while on
   ENDIF                               ;  an adjacent menu.  Therefor, we don't
   loop.l = (key.n > 0)                ;  want to execute this procedure.
   Return
ENDPROC
WriteLib libname.a MainLocate.u
Release PROCS      MainLocate.u
?? ""
; ===========================================================================
;       TITLE: MainSelect.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 01:20:26pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MainSelect.u()
Private  item.r,                          ; Array of Dropdown Menu Items
         page.a,                          ; Field to MoveTo on Form
         proc.a,                          ; Name of current procedure
         proc.r                           ; Array of Procedures to Call
   proc.a = "MainSelect.u"
   IF item.n = 0 THEN
      Return
   ENDIF
   page.a = "S" + StrVal(item.n)
   MoveTo FIELD page.a
   Array item.r[4]   Array proc.r[4]
      item.r[1]   = "FORMPICK  - Select from List"
      proc.r[1]   = "SelectFormPick.u"
      item.r[2]   = "INS_PICK  - Insert New Record"
      proc.r[2]   = "SelectIns_Pick.u"
      item.r[3]   = "ARRAYPICK - Array-based Lookup"
      proc.r[3]   = "SelectArrayPick.u"
      item.r[4]   = "POPUPFORM - Popup Lookup Form"
      proc.r[4]   = "SelectPopupForm.u"
   execproc.a = MenuPull.u(spot.r[item.n],27,63)
   Return
ENDPROC
WriteLib libname.a MainSelect.u
Release PROCS      MainSelect.u
?? ""
; ===========================================================================
;       TITLE: MainGet_Input.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 03:43:14pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MainGet_Input.u()
Private  item.r,                          ; Array of Dropdown Menu Items
         page.a,                          ; Field to MoveTo on Form
         proc.a,                          ; Name of current procedure
         proc.r                           ; Array of Procedures to Call

   proc.a = "MainGet_Input.u"
   IF item.n = 0 THEN
      Return
   ENDIF
   page.a = "S" + StrVal(item.n)
   MoveTo FIELD page.a
   Array item.r[3]   Array proc.r[3]
      item.r[1]   = "ACCEPT   - Date from User"
      proc.r[1]   = "Get_InputAccept.u"
      item.r[2]   = "VALIDATE - Accepted Data"
      proc.r[2]   = "Get_InputValidate.u"
      item.r[3]   = "QBFORM   - Query By Form"
      proc.r[3]   = "Get_InputQBForm.u"
   execproc.a = MenuPull.u(spot.r[item.n],27,63)
   Return
ENDPROC
WriteLib libname.a MainGet_Input.u
Release PROCS      MainGet_Input.u
?? ""
; ===========================================================================
;       TITLE: MainPrinting.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 01:20:26pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MainPrinting.u()
Private  item.r,                          ; Array of Dropdown Menu Items
         page.a,                          ; Field to MoveTo on Form
         proc.a,                          ; Name of current procedure
         proc.r                           ; Array of Procedures to Call

   proc.a = "MainPrinting.u"
   IF item.n = 0 THEN
      Return
   ENDIF
   page.a = "S" + StrVal(item.n)
   MoveTo FIELD page.a
   Array item.r[4]   Array proc.r[4]
      item.r[1]   = "FILE     - Send Report to File"
      proc.r[1]   = "PrintingFile.u"
      item.r[2]   = "OUTPUT   - Select Destination"
      proc.r[2]   = "PrintingOutput.u"
      item.r[3]   = "CHECKPRN - CheckPrinter Routine"
      proc.r[3]   = "PrintingCheckPrn.u"
      item.r[4]   = "RESTART  - Report from Any Page"
      proc.r[4]   = "PrintingRestart.u"
   execproc.a = MenuPull.u(spot.r[item.n],27,63)
   Return
ENDPROC
WriteLib libname.a MainPrinting.u
Release PROCS      MainPrinting.u
?? ""
; ===========================================================================
;       TITLE: MainVarious.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 03:43:04pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MainVarious.u()
Private  item.r,                          ; Array of Dropdown Menu Items
         page.a,                          ; Field to MoveTo on Form
         proc.a,                          ; Name of current procedure
         proc.r                           ; Array of Procedures to Call

   proc.a = "MainVarious.u"
   IF item.n = 0 THEN
      Return
   ENDIF
   page.a = "S" + StrVal(item.n)
   MoveTo FIELD page.a
   Array item.r[5]   Array proc.r[5]
      item.r[1]   = "LISTING - See List of Procs"
      proc.r[1]   = "VariousListing.u"
      item.r[2]   = "ERROR   - Problem Handler"
      proc.r[2]   = "VariousError.u"
      item.r[3]   = "PACK    - Table Packer"
      proc.r[3]   = "VariousPack.u"
      item.r[4]   = "RECOVER - Family Recover"
      proc.r[4]   = "VariousRecover.u"
      item.r[5]   = "OTHERS  - Various Procedures"
      proc.r[5]   = "VariousOthers.u"
   execproc.a = MenuPull.u(spot.r[item.n],27,63)
   Return
ENDPROC
WriteLib libname.a MainVarious.u
Release PROCS      MainVarious.u
?? ""
; ---------------------------------------------------------------------------
;       Title: ShowMainMenu.u
;      Author: (c) 1991 - Daniel J. Paolini II, CMA
;     Returns: No value
;  Chronology: Created: 07/04/90 09:20am   Revised: 07/05/90 08:31am
; Description: Main menu for Demo Procedures, Closed for memory management
; ---------------------------------------------------------------------------
PROC Closed ShowMainMenu.u(autolib,     ; pass autolib string and setswap #
                           mem.n,
                           disk.n,
                           cfgtable.a,
                           errorlib.a)

   proc.a = "MainMenu.u"                  ; name of procedure for error handler,
                                          ;   as Paradox cannot tell you what
                                          ;   proc had the error
   errorproc = "ErrorHandler.n"           ; assigns my error handling procedure,
                                          ;   which is variation on Alan Z's.
   ReadLib errorlib.a ErrorHandler.n      ; explicitly place errorproc in calling
                                          ;   chain, so Paradox can find it no
                                          ;   matter what (almost!)
   IF Version() < 3 THEN                  ; check version
      PopBox.u(10,"Sorry, you need Paradox 3.# for this Demo",0,SysColor(3),3)
      QUIT "Paradox 3.5 is well worth the upgrade investment"
   ENDIF
   Startup.l()
   IF NOT retval THEN
      Return
   ENDIF
;   PrinterSetupProc.u()
   elite.a     = "\027\019\027\29"        ; Elite printer control string
   pica.a      = "\027\019\027\018"       ; Pica printer control string
   condensed.a = "\027\020"               ; Condensed printer control string
   port.a      = "PRN"                    ; Default printer port
   Sleep 2000
   ClearAll
   mainmenu.a = "LOCATE"                  ; set default, which allows menu choice
                                          ;   to be "sticky"
   WHILE true                             ; LOOP 'til we DROOP
      Canvas OFF                          ; turn off canvas while we paint
      Clear
      @2,0                                ; place menu screen below prompts
Text
   Use  and  Keys to move around Menu, then  to choose Highlighted item.

                      HOW TO USE DAN'S DEMO MAIN MENU      
                
    LOCATE    Use menu-driven Incremental, Fuzzy, Zoom or Multi-Field Locates
               to Find a Record or Value.
    SELECT    Select Records or Table Lookup Values from a Pick List, with or
               without Adding New Values on the fly using SmartKey routine.
 GET_INPUT    Enter information for use in a Program, with or without Data
               Validation.  Perform an Ad Hoc, Free-form Query.
  PRINTING    Output a Report to a File.  Use a Printer Destination Menu.
               Use a Printer Status routine.  Restart a Report printed from
               a DOS file from any selected Page.
   VARIOUS    View a Listing of these Utility Procedures, using a low-impact
               substitute for the Data Entry Toolkit.  View the Errorhandling
               Procedure.  Pack or Rebuild Tables.  Restore Family Objects.
               Demonstrate several other Miscellaneous procedures.
  Key Help  
   [Alt+H]    to Get Context-Sensitive Help at Any Time.
  [Ctrl]-B    to See Random Boxes in Random Colors Pop Up on the Screen.
     [Esc]    to Cancel or to back Up through Menu Choices made.
              You can also select Menu Items using first letter of the Item.

EndText
   PaintMenu.u()                             ; paint menu procedure
   Canvas ON                               ; lights - camera - action
   SHOWMENU
      "LOCATE"    : "Use the Locate Menu to Find a Record",
      "SELECT"    : "Select Records or Lookup Values",
      "GET_INPUT" : "Obtain Input or perform Ad Hoc Queries",
      "PRINTING"  : "Demonstrate Various Printing Routines",
      "VARIOUS"   : "Demonstrate Various Miscellaneous Procedures",
      "QUIT"      : "Return to from Whence You Came"
   Until "F1", -35,                       ; Context-sensitive Help keys
         "Esc",                           ; Alternate QUIT key
          2                               ; [Ctrl]B for Popup Boxes
   KeyTo key.v
   DEFAULT mainmenu.a                     ; make selections "sticky"
   To mainmenu.a                          ; assign menu choice variable

   SWITCH
      CASE key.v = 2             : BoxDemo.u()
      CASE (key.v = "F1" OR key.v = -35)
       AND mainmenu.a = "QUIT"   : Beep
      CASE key.v = "F1"
        OR key.v = -35           : HelpMenu.u(mainmenu.a)
      CASE NOT retval
        OR mainmenu.a = "QUIT"   :
         Canvas OFF
         View "D\\ddemocfg"
         PickForm (1 + form.n)
         MoveTo [X]
         Echo NORMAL Echo OFF
         Prompt.u("Are You Sure?",0)
         PaintCanvas FILL "" ATTRIBUTE 79  1,0,1,79
         MenuPop2.l(1, 26, "Quit this Demonstration?", "YES", "NO",
                   "Return to DOS",
                   "Continue with Demo",
                    79, 78, 30, true)
         IF retval THEN
            ; Add Departure Routines here
            ClosingCredits.u()
            Clear ClearAll
            Return
         ENDIF
      OTHERWISE                  : ExecProc mainmenu.a+ "Demo.u"
         ; User made menu selection:
         ;    by naming the sub-procedures the same as the menu choices, you
         ;    can use the ExecProc [menuchoice] + ".u" code to eliminate
         ;    quite a few lines of code in the SWITCH statement.  Contrary
         ;    to popular belief, EXECPROC does not inhibit proc swapping.
   ENDSWITCH
ENDWHILE
ENDPROC
WriteLib libname.a ShowMainMenu.u       ; write this proc to a library
Release PROCS ShowMainMenu.u            ; release it from memory
?? ""                                  ; entertain the MAKELIB user
; ===========================================================================
;       TITLE: SelectDemo.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 03-03-91 10:54:14pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC SelectDemo.u()
Private  submenu.a,
         proc.a                           ; Name of current procedure
   proc.a = "SelectDemo.u"
   submenu.a = "FORMPICK"                 ; set default, which allows menu choice
                                          ;   to be "sticky"
   WHILE true                             ; LOOP 'til we DROOP
      Canvas OFF                          ; turn off canvas while we paint
      Clear
      @2,0                                ; place menu screen below prompts
Text
   Use  and  Keys to move around Menu, then  to choose Highlighted item.

                        HOW TO USE THE SELECT MENU         
                

  FORMPICK    Select a Record for Processing from a Form.  This eliminates
               errors that may occur if you ask the User to type in Values.

  INS_PICK    Select a Record for Processing from a Form, as above, but with
               the ability to add a New Record on the fly if it is not there.

 ARRAYPICK    Select a Table Lookup Value from a Popup Window, which uses an
               Incremental Search to choose Values to display in the Window.

 POPUPFORM    Select a Table Lookup Value from an Embedded Form, which
               appears as a Popup Window, with ability to add New Values.

  Key Help  
   [Alt+H]    to Get Context-Sensitive Help at Any Time.
     [Esc]    to Cancel or to back Up through Menu Choices made.
              You can also select Menu Items using first letter of the Item.
            

EndText
   PaintMenu.u()                             ; paint menu procedure
   Canvas ON                               ; lights - camera - action
   SHOWMENU
      "FORMPICK"  : "Select Record from Form",
      "INS_PICK"  : "Select Record from Form, and Add New Record",
      "ARRAYPICK" : "Select Lookup Value from Popup Window",
      "POPUPFORM" : "Select Lookup Value, and Add New Values",
      "RETURN"    : "Return to MAIN MENU"
   Until "F1", -35,                       ; Context-sensitive Help keys
         "Esc"                            ; Alternate QUIT key
   KeyTo key.v
   DEFAULT submenu.a                     ; make selections "sticky"
   To submenu.a                          ; assign menu choice variable

   SWITCH
      CASE (key.v = "F1" OR key.v = -35)
       AND submenu.a = "RETURN"  : Beep
      CASE key.v = "F1"
        OR key.v = -35           : HelpMenu.u(submenu.a)
      CASE NOT retval
        OR submenu.a = "RETURN"  : Return
      OTHERWISE                  : ExecProc "Select" +submenu.a+ ".u"
   ENDSWITCH
ENDWHILE
ENDPROC
WriteLib libname.a SelectDemo.u
Release PROCS      SelectDemo.u
?? ""
; ===========================================================================
;       TITLE: Get_InputDemo.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 03-03-91 10:54:36pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC Get_InputDemo.u()
Private  submenu.a,
         proc.a                           ; Name of current procedure
   proc.a = "Get_InputDemo.u"
   submenu.a = "ACCEPT"                   ; set default, which allows menu choice
                                          ;   to be "sticky"
   WHILE true                             ; LOOP 'til we DROOP
      Canvas OFF                          ; turn off canvas while we paint
      Clear
      @2,0                                ; place menu screen below prompts
Text
   Use  and  Keys to move around Menu, then  to choose Highlighted item.

                       HOW TO USE THE GET INPUT MENU       
                

    ACCEPT    Input a Value into a standard Popup Window.


  VALIDATE    Input a Value into a standard Popup Window, with Data
               Validation.


    QBFORM    Use a Form to accept Query criteria for an Ad hoc Query,
               while eliminating potential destructive commands.



  Key Help  
   [Alt+H]    to Get Context-Sensitive Help at Any Time.
     [Esc]    to Cancel or to back Up through Menu Choices made.
              You can also select Menu Items using first letter of the Item.
            

EndText
   PaintMenu.u()                             ; paint menu procedure
   Canvas ON                               ; lights - camera - action
   SHOWMENU
      "ACCEPT"    : "Input Requested Data",
      "VALIDATE"  : "Input Requested Data with Data Validation",
      "QBFORM"    : "Use Query By Form to perform Ad hoc Query",
      "RETURN"    : "Return to MAIN MENU"
   Until "F1", -35,                       ; Context-sensitive Help keys
         "Esc"                            ; Alternate QUIT key
   KeyTo key.v
   DEFAULT submenu.a                     ; make selections "sticky"
   To submenu.a                          ; assign menu choice variable

   SWITCH
      CASE (key.v = "F1" OR key.v = -35)
       AND submenu.a = "RETURN"  : Beep
      CASE key.v = "F1"
        OR key.v = -35           : HelpMenu.u(submenu.a)
      CASE NOT retval
        OR submenu.a = "RETURN"  : Return
      OTHERWISE                  : ExecProc "Get_Input" +submenu.a+ ".u"
   ENDSWITCH
ENDWHILE

ENDPROC
WriteLib libname.a Get_InputDemo.u
Release PROCS      Get_InputDemo.u
?? ""
; ===========================================================================
;       TITLE: PrintingDemo.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 03-03-91 10:54:55pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC PrintingDemo.u()
Private  submenu.a,
         proc.a                           ; Name of current procedure
   proc.a = "PrintingDemo.u"
   submenu.a = "FILE"                     ; set default, which allows menu choice
                                          ;   to be "sticky"
   WHILE true                             ; LOOP 'til we DROOP
      Canvas OFF                          ; turn off canvas while we paint
      Clear
      @2,0                                ; place menu screen below prompts
Text
   Use  and  Keys to move around Menu, then  to choose Highlighted item.

                       HOW TO USE THE PRINTING MENU        
                

      FILE    Output a Report to a DOS File.  This allows you to Display or
               Print the Report as many times as necessary.  It demonstrates
               using README.com to Display the Report on the Screen, as well.

    OUTPUT    Display an Output Destination Menu, and select from the Default
               Printer, the Screen, a File, or a Selected Override Port.

  CHECKPRN    Demonstrate a Check Printer Status Routine.

   RESTART    Restart a Report printed from a DOS File, from any Selected
               Page number.

  Key Help  
   [Alt+H]    to Get Context-Sensitive Help at Any Time.
     [Esc]    to Cancel or to back Up through Menu Choices made.
              You can also select Menu Items using first letter of the Item.
            

EndText
   PaintMenu.u()                             ; paint menu procedure
   Canvas ON                               ; lights - camera - action
   SHOWMENU
      "FILE"      : "Output to a File and Display on Screen",
      "OUTPUT"    : "Select Output Destination from Menu",
      "CHECKPRN"  : "Demonstrate Check Printer Status Routine",
      "RESTART"   : "Restart a DOS File Report from a Selected Page",
      "RETURN"    : "Return to MAIN MENU"
   Until "F1", -35,                       ; Context-sensitive Help keys
         "Esc"                            ; Alternate QUIT key
   KeyTo key.v
   DEFAULT submenu.a                     ; make selections "sticky"
   To submenu.a                          ; assign menu choice variable

   SWITCH
      CASE (key.v = "F1" OR key.v = -35)
       AND submenu.a = "RETURN"  : Beep
      CASE key.v = "F1"
        OR key.v = -35           : HelpMenu.u(submenu.a)
      CASE NOT retval
        OR submenu.a = "RETURN"  : Return
      OTHERWISE                  : ExecProc "Printing" +submenu.a+ ".u"
   ENDSWITCH
ENDWHILE

ENDPROC
WriteLib libname.a PrintingDemo.u
Release PROCS      PrintingDemo.u
?? ""
; ===========================================================================
;       TITLE: VariousDemo.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 03-03-91 10:55:08pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC VariousDemo.u()
Private  submenu.a,
         proc.a                           ; Name of current procedure
   proc.a = "VariousDemo.u"
   submenu.a = "LISTING"                  ; set default, which allows menu choice
                                          ;   to be "sticky"
   WHILE true                             ; LOOP 'til we DROOP
      Canvas OFF                          ; turn off canvas while we paint
      Clear
      @2,0                                ; place menu screen below prompts
Text
   Use  and  Keys to move around Menu, then  to choose Highlighted item.

                        HOW TO USE THE VARIOUS MENU        
                

   LISTING    View a Listing of these Utility Procedures and their Parameters
               using a low-impact substitute for the Data Entry Toolkit.

     ERROR    Demonstrate the Error Handling procedure.

      PACK    Restructure and Rebuild all Tables used by this Application.

   RECOVER    Recover all Family Objects for Tables in this Application.

    OTHERS    View several different Miscellaneous procedures, and Select
               viewing speed from a Menu.

  Key Help  
   [Alt+H]    to Get Context-Sensitive Help at Any Time.
     [Esc]    to Cancel or to back Up through Menu Choices made.
              You can also select Menu Items using first letter of the Item.
            

EndText
   PaintMenu.u()                             ; paint menu procedure
   Canvas ON                               ; lights - camera - action
   SHOWMENU
      "LISTING"   : "Display the Utility Procedures",
      "ERROR"     : "Demonstrate the Error Handler",
      "PACK"      : "Restructure and Rebuild All Tables",
      "RECOVER"   : "Recover Family Objects for All Tables",
      "OTHERS"    : "Demonstrate Various Miscellaneous Procedures",
      "RETURN"    : "Return to MAIN MENU"
   Until "F1", -35,                       ; Context-sensitive Help keys
         "Esc"                            ; Alternate QUIT key
   KeyTo key.v
   DEFAULT submenu.a                     ; make selections "sticky"
   To submenu.a                          ; assign menu choice variable

   SWITCH
      CASE (key.v = "F1" OR key.v = -35)
       AND submenu.a = "RETURN"  : Beep
      CASE key.v = "F1"
        OR key.v = -35           : HelpMenu.u(submenu.a)
      CASE NOT retval
        OR submenu.a = "RETURN"  : Return
      OTHERWISE                  : ExecProc "Various" +submenu.a+ ".u"
   ENDSWITCH
ENDWHILE

ENDPROC
WriteLib libname.a VariousDemo.u
Release PROCS      VariousDemo.u
?? ""
; ---------------------------------------------------------------------------
;       Title - BoxDemo.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No value
;  Chronology - Created: 07/05/90 03:18am    Revised: 01-15-91 07:42pm
; Description - Displays the three versions of PopBox.u twice, in random
;               locations and colors.  Why is this proc here?  Just to show
;               the use of the Rand() function, and to see pretty (and not so
;               pretty) colors.  Some are quite interesting <g>.
; ---------------------------------------------------------------------------
PROC BoxDemo.u()
Private n,                                ; attribute number
        proc.a                            ; Identifies proc to errorproc

   proc.a = "BoxDemo.u"
   IF color.l THEN                        ; color display
      n = Int(43*Rand())                  ; randomize from 0 to 43 (I add 17, 34,
                                          ;   51, 68 and 85 to get 5 more values)
; ---------------------------------------------------------------------------
; If an attribute number is evenly divisible by 17, then the foreground = the
;   background color.  This makes reading messages a challenge <g>.  So we
;   test for this, and if so, increment the attribute by 1
; ---------------------------------------------------------------------------
      IF Mod(n,17) = 0 THEN
         n = n + 1
      ENDIF
   ELSE                                    ; B&W/Momochrome
      n = SysColor(3)
   ENDIF

   PopBox.u(Int((22*Rand())+1),"Short Message - Block Box",0,n,1)
   PopBox.u(Int((22*Rand())+1),"Double-line Box",2,n+17,1)
   PopBox.u(Int((22*Rand())+1),"Box",1,n+34,1)
   PopBox.u(Int((22*Rand())+1),"A Medium Message in a Single-line Box",1,n+51,1)
   PopBox.u(Int((22*Rand())+1),"This is a Longer Message within a Double-line Box",
            2,n+68,1)
   PopBox.u(Int((22*Rand())+1),
            "This would be the Longest Message Available  -  Press any Key to Continue",
            0,n+85,1)
   Beep Sleep 100 Beep Sleep 100 Beep
   retval = GetChar()                      ; admire our work until a keystroke
ENDPROC

WriteLib libname.a BoxDemo.u
Release PROCS BoxDemo.u
?? ""
; ---------------------------------------------------------------------------
;       Title - ClosingCredits.u
;      Author - (c) 1990 - Daniel J. Paolini II, CMA
;     Returns -
;  Chronology - Created:
; Description -
; ---------------------------------------------------------------------------
PROC ClosingCredits.u()
Private proc.a
   proc.a = "ClosingCredits.u"
   Array credits.r[55]
      credits.r[1]  = Spaces(44)
      credits.r[2]  = Spaces(44)
      credits.r[3]  = Spaces(44)
      credits.r[4]  = Spaces(44)
      credits.r[5]  = Spaces(44)
      credits.r[6]  = Spaces(44)
      credits.r[7]  = Spaces(44)
      credits.r[8]  = Spaces(44)
      credits.r[9]  = Spaces(44)
      credits.r[10] = Spaces(44)
      credits.r[11] = Spaces(44)
      credits.r[12] = Spaces(44)
      credits.r[13] = Spaces(44)
      credits.r[14] = Spaces(44)
      credits.r[15] = Spaces(44)
      credits.r[16] = Format("w44,ac","This is the Dan's Demo Credits System")
      credits.r[17] = Format("w44,ac","brought to you by")
      credits.r[18] = Spaces(44)
      credits.r[19] = Format("w44,ac","dp Solutions, Inc.")
      credits.r[20] = Format("w44,ac","the Paradox (R) People, specializing in")
      credits.r[21] = Spaces(44)
      credits.r[22] = Format("w44,ac","Paradox Applications Development")
      credits.r[23] = Format("w44,ac","Interactive Paradox and PAL Training")
      credits.r[24] = Format("w44,ac","Paradox Application Performance Tuning")
      credits.r[25] = Spaces(44)
      credits.r[26] = Format("w44,ac","These procedures are based upon the work of")
      credits.r[27] = Spaces(44)
      credits.r[28] = Format("w44,ac","Steve Caple")
      credits.r[29] = Format("w44,ac","Tim Colling")
      credits.r[30] = Format("w44,ac","Steve Dickerson")
      credits.r[31] = Format("w44,ac","Dan Ehrmann")
      credits.r[32] = Format("w44,ac","Joe Fusco")
      credits.r[33] = Format("w44,ac","David Kelton")
      credits.r[34] = Format("w44,ac","Jim Kocis")
      credits.r[35] = Format("w44,ac","Dan Paolini")
      credits.r[36] = Format("w44,ac","Patty Paolini")
      credits.r[37] = Format("w44,ac","Brian Smith")
      credits.r[38] = Format("w44,ac","Alan Zenreich")
      credits.r[39] = Format("w44,ac","and Paradox Developers everywhere")
      credits.r[40] = Spaces(44)
      credits.r[41] = Format("w44,ac","Paradox is a Registered Trademark of")
      credits.r[42] = Format("w44,ac","Borland International, Inc.")
      credits.r[43] = Spaces(44)
      credits.r[44] = Spaces(44)
      credits.r[45] = Spaces(44)
      credits.r[46] = Spaces(44)
      credits.r[47] = Spaces(44)
      credits.r[48] = Spaces(44)
      credits.r[49] = Spaces(44)
      credits.r[50] = Spaces(44)
      credits.r[51] = Spaces(44)
      credits.r[52] = Spaces(44)
      credits.r[53] = Spaces(44)
      credits.r[54] = Spaces(44)
      credits.r[55] = Spaces(44)
   Canvas OFF
   PaintCanvas BORDER FILL "" 4, 15, 20, 64
   PaintCanvas FILL " "        5, 16, 19, 63
   @  4,16 ?? Fill("",48)
   @ 20,16 ?? Fill("",48)
   IF color.l THEN
      PaintCanvas ATTRIBUTE  2   4, 15, 20, 64
   ENDIF
   @  4,34 ?? " Dan's Demo "
   IF color.l THEN
      PaintCanvas ATTRIBUTE 47   4, 34,  4, 45
      PaintCanvas ATTRIBUTE  8   5, 65, 20, 66
      PaintCanvas ATTRIBUTE  8  21, 17, 21, 66
   ELSE
      PaintCanvas REVERSE    4, 34,  4, 45
   ENDIF
   Canvas ON
   IF color.l THEN
      Style ATTRIBUTE 14
   ELSE
      Style INTENSE
   ENDIF

   FOR n From 0 To 39
      Canvas OFF
      @  5,18 ?? credits.r[n+1]
      @  6,18 ?? credits.r[n+2]
      @  7,18 ?? credits.r[n+3]
      @  8,18 ?? credits.r[n+4]
      @  9,18 ?? credits.r[n+5]
      @ 10,18 ?? credits.r[n+6]
      @ 11,18 ?? credits.r[n+7]
      @ 12,18 ?? credits.r[n+8]
      @ 13,18 ?? credits.r[n+9]
      @ 14,18 ?? credits.r[n+10]
      @ 15,18 ?? credits.r[n+11]
      @ 16,18 ?? credits.r[n+12]
      @ 17,18 ?? credits.r[n+13]
      @ 18,18 ?? credits.r[n+14]
      @ 19,18 ?? credits.r[n+15]
      Canvas ON
      Sleep 500
   ENDFOR
   FOR n From 1 TO 35
      @ 12,18 ?? SubStr(Spaces(44)+"Thanks for Your Support!          ",n,44)
      Sleep 100
   ENDFOR
   Sleep 2000
ENDPROC
WriteLib libname.a ClosingCredits.u
Release PROCS ClosingCredits.u
?? ""
