? " Utility1.sc"
@ Row(),13 ?? Fill("",26)
@ Row(),13
libname.a = "Utility"
IF NOT IsFile(libname.a + ".LIB") THEN
   CreateLib libname.a SIZE 100
ENDIF
; ===========================================================================
; APPLICATION: Dan's Utility Procedures Demo
;    CONTENTS: 65 Utility Procedures
;      AUTHOR: (c) 1991 Daniel J. Paolini II, CMA
;              (c) 1991 dp Solutions, Inc. - All Rights Reserved
;              Portions of Code (c) 1991 Zenreich Systems
;              Portions of Code (c) 1991 The Burgiss Group
;              Portions of Code (c) 1991 Pal by Example
;              Compilation Copyright (c) 1991 - Daniel J. Paolini II
;     STARTED: August, 1989           Last revised - 03-01-91 08:39pm
; LIMITATIONS: These programs may be used or modified by anyone for any
;              non-commercial reason, provided the author(s) are acknowledged.
;              Developers may include all or parts of these files as a
;              supplement to individual commercial applications, but in no
;              event are these files to be marketed as a separate commercial
;              product without the express permission of the author(s).
;              No representation is made as to the usefulness or suitability
;              of these programs for any purpose.
; ===========================================================================
;       TITLE: Beeper.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;              Based upon an idea by Alan Zenreich
;     CREATED: March, 1988          LAST REVISED: 11/21/90
;     RETURNS: No Value
; DESCRIPTION: Generic wait for keypress and annoy user beeper.
; ---------------------------------------------------------------------------
PROC Beeper.u()
Private  uproc.a,                         ; Name of current procedure
         beep.n                           ; Current sleep value, initially 2350
   uproc.a = "Beeper.u"
   WHILE CharWaiting()                    ; Clear keyboard buffer
      retval = GetChar()
   ENDWHILE
   Style ATTRIBUTE SysColor(3)            ; message color
   @ 3,0
   ?? Format("w80,ac","  Please Hit Any Key to Continue  ")
   Style                                  ; Reset style
   beep.n = 2350                          ; Initialize at 2 second delay
   WHILE not CharWaiting()                ; Until any keypress
      Beep Sleep 50 Beep Sleep 50 Beep    ; 3 beeps separated by brief pause
      IF beep.n > 500 THEN                ; Until we get to half-second pause
         beep.n = Int(beep.n * .85)       ;    decrease the pause each time
      ENDIF
      Sleep beep.n                        ; Pause for new amount
   ENDWHILE
   retval = GetChar()                     ; Clear the keypress
   Clear Return
ENDPROC
WriteLib libname.a Beeper.u
Release PROCS      Beeper.u
?? ""
; ===========================================================================
;       TITLE: CancelSession.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: June, 1988              Last Revised: 01-01-91 11:40pm
;     RETURNS: Logical True/False if Session Canceled
; DESCRIPTION: Generic Data Session Cancelation
; ---------------------------------------------------------------------------
PROC CancelSession.l(prompt.a)            ; Prompt to use on Line 3
Private  uproc.a,                          ; Name of current procedure
         l
   uproc.a = "CancelSession.l"
   Prompt " Are You Sure You Want to Cancel this Session?..",""
   SWITCH
      CASE ImageType() = "Query" :
         l = MenuPop2.l(2, 0, prompt.a, "NO", "YES",
                       "Do not Cancel this Query",
                       "Cancel this Query",
                        79, 78, 14, false)
         IF l THEN
            Message.u("C",1,1)
            WHILE ImageType() = "Query"
               ClearImage
            ENDWHILE
         ENDIF
      CASE SysMode() = "Edit" OR SysMode() = "DataEntry" :
         l = MenuPop2.l(2, 0, prompt.a, "NO", "YES",
                       "Do not Cancel this Session",
                       "Cancel this Session",
                        79, 78, 14, false)
         IF l THEN
            Message.u("C",1,1)
            CancelEdit
            ClearAll
         ENDIF
      OTHERWISE   :
         l = MenuPop2.l(2, 0, prompt.a, "NO", "YES",
                       "Do not Stop this Session",
                       "Quit this Session",
                        79, 78, 14, false)
         IF l THEN
            Do_It!
            ClearAll
         ENDIF
   ENDSWITCH
   Prompt
   Return l
ENDPROC
WriteLib libname.a CancelSession.l
Release PROCS      CancelSession.l
?? ""
; ===========================================================================
;       TITLE: CoEditKey.l
;      AUTHOR: (c) 1991 - Alan Zenreich/James Kocis
;  REVISED BY: Daniel J. Paolini II    Last Revised: 01-01-91 11:48pm
;     RETURNS: Logical True/False if successful
; DESCRIPTION: Tests to see if the workspace can be put into CoEdit mode
; ---------------------------------------------------------------------------
PROC CoEditKey.l()
Private  uproc.a                           ; Name of current procedure
   uproc.a = "CoEditKey.l"
   CoEditKey
   SWITCH
      CASE ErrorCode() = 3 or ErrorCode() = 62 :
         Message.u(erroruser()+" is using this table in another form",-1,0)
         Return false
      OTHERWISE:
         Return true
   ENDSWITCH
ENDPROC
WriteLib libname.a CoEditKey.l
Release PROCS      CoEditKey.l
?? ""
; ===========================================================================
;       TITLE: CopyFromArray3.u
;      AUTHOR: (c) 1991 - Alan Zenreich/James Kocis
;  REVISED BY: Daniel J. Paolini II    Last Revised: 01-01-91 11:48pm
;     RETURNS: No Value
; DESCRIPTION: Simulates CopyFromArray from embedded detail table
; ---------------------------------------------------------------------------
PROC CopyFromArray3.u(arrayname.a,        ; Name of array to copy from
                      requiredcheck.l)    ; If false, then RequiredCheck OFF
; linkedkeys.n       Optional global variable, if set, tells CopyFromaArray3.u
;                    how many keys to avoid placing.  This is necessary only in
;                    one odd circumstance described below.
Private  fields.n,                        ; Number of fields in table.
         n ,                              ; Field counter.
         linked.n,                        ; Number of linked keys specified by
                                          ;  optional variable linkedkeys.n
         errorproc                        ; Name of error procedure.
;Global  linkedkeys.n                     ; Optional global variable, if set,
                                          ;  tells CopyFromaArray3.u how many
                                          ;  keys to avoid placing.
   PROC CopyError.n()
   ; Requires an error procedure to handle link and required field errors.  The
   ;  proc is kept small because the EXECUTE disables procedure swapping.
      SWITCH
         ; This traps for linked fields, empty master records and required fields.
         CASE (Errorcode() = 60 AND
               Match (Errormessage(),"..linked fields in ..") OR
               Match (Errormessage(),"..master record is blank..")) OR
            (Errorcode() = 23 AND Match(ErrorMessage(),"..value must be provided..")):
            ErrorReset.u()
            Return 1
         OTHERWISE:                          ; An unanticipated script error.
            Message "CopyFromArray3.u has found Errorcode() =",
            ErrorCode(), "  "+ ErrorMessage()+"   Press any key."
            retval = GetChar()
            Return 2                         ; Cancels Script/Application
      ENDSWITCH
   ENDPROC

   RequiredCheck OFF                      ; So Required field doesn't stall us
   errorproc = "CopyError.n"              ; Set name of error handler
   fields.n = NFields(Table())

   IF NOT IsAssigned (linkedkeys.n) THEN
      linked.n = 0
   ELSE
      linked.n = linkedkeys.n
   ENDIF

   {Image} {Zoom} {Field}
   FOR n From 1 To fields.n               ; Step through field names
      IF n > linked.n THEN
         Execute "[" + MENUCHOICE() + "]=" + arrayname.a + "[n+1]"
      ; For example, if the first field is [Cust#] the execute would prepare:
      ;  [Cust#]=record.r[2]              ; The second element of the array.
      ENDIF
      Right                               ; Go on to the next field name.
   ENDFOR

   CtrlBreak                              ; Back out of the zoom/field.
   IF requiredcheck.l <> false THEN
      RequiredCheck ON
   ENDIF
   Release PROCS copyerror.n              ; Remove error proc from memory.
   Return
ENDPROC
WriteLib libname.a CopyFromArray3.u
Release PROCS      CopyFromArray3.u
?? ""
; ===========================================================================
;       TITLE: CreateTable.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 03/02/90 12:06pm        Last Revised: 01-11-91 09:10pm
;     RETURNS: No Value
; DESCRIPTION: Creates a table like a table, and copies family
; ---------------------------------------------------------------------------
PROC CreateTable.l(source.a,              ; Source table
                   target.a)              ; New table
Private  uproc.a,                         ; Name of this procedure
         a1,a2,a3,a4,
         lock.a                           ; Lock string for lock procedure
   uproc.a = "CreateTable.l"
   IF NOT IsTable(source.a) THEN
      Message.u("Table " +table.a+ " was not found!",5,5)
      Return false
   ENDIF

   a1 = source.a
   a2 = ""
   WHILE Match(a1,"..\\..",a3,a1)
      a2 = a2 + a3 +"\\\\"
   ENDWHILE
   IF a1 <> source.a THEN
      a4 = a2 + a1
   ELSE
      a4 = source.a
   ENDIF

   lock.a = "\"" +a4+ "\" PFL"
   LockTable.l(lock.a)
   IF NOT retval THEN
      Return false
   ENDIF

   Create target.a LIKE source.a
   {Tools} {Copy} {JustFamily} SELECT source.a SELECT target.a {Replace}
   UnLock source.a PFL
   Return true
ENDPROC
WriteLib libname.a CreateTable.l
Release PROCS CreateTable.l
?? ""
; ===========================================================================
;       Title - DeleteRecord.l
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - Logical true/false if record deleted
;  Chronology - Created: 11/22/90 10:52:40pm    Revised: 01-11-91 09:11pm
; Description -
; ---------------------------------------------------------------------------
PROC DeleteRecord.l()
Private  uproc.a,
         l
   uproc.a = "DeleteRecord.l"
   Prompt "Please confirm Record Deletion for Record #" +StrVal(RecNo())+ " in the " +Table()+ " Table...",
          Fill("",80)
   HilightRecord.u()
   l = MenuPop2.l(1, 22, " Are You Sure? ", "CANCEL", "DO-IT!",
                 "Do NOT Delete this Record",
                 "Delete this Record",
                  79, 78, 14, false)
   IF l THEN
      ImageRights
      Del
   ENDIF
   Prompt
   Return l
ENDPROC
WriteLib libname.a DeleteRecord.l
Release PROCS DeleteRecord.l
?? ""
; ===========================================================================
;       Title - DeleteTable.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - no value
;  Chronology - Created: October, 1987     Last revised: 01-11-91 09:11pm
; Description - Generic Delete Table
; ---------------------------------------------------------------------------
PROC DeleteTable.u(table.a)            ; Name of table to delete
Private uproc.a
   uproc.a = "DeleteTable.u"
   Message.u("W",0,0)
   IF IsTable(table.a) THEN
      Delete table.a
   ENDIF
   Clear Return
ENDPROC
WriteLib libname.a DeleteTable.u
Release PROCS DeleteTable.u
?? ""
; ===========================================================================
;       Title - EmptyTable.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - no value
;  Chronology - Created: October, 1987     Last revised: 09/17/90 04:21pm
; Description - Generic Empty Table
;               I don't use EMPTY very much anymore, because of the bug that
;               can cause you to loose a table that was emptied but not flushed
;               from the buffers to disk.  Instead, I keep an empty template
;               table, from which I create a temporary working table using a
;               Paradox temporary table name (FAMILY, ANSWER, ENTRY###, etc.).
;               Paradox deletes these automatically - same basic result.  In
;               this proc, checking to see if table is not already empty has
;               worked for me to avoid the bug.  Zenreich and Kocis suggest
;               the {Tools} line of code.
; ---------------------------------------------------------------------------
PROC EmptyTable.u(table.a)             ; Name of table to empty
Private uproc.a
   uproc.a = "EmptyTable.u"
   Message.u("W",0,0)
   IF IsTable(table.a) AND not IsEmpty(table.a) THEN
      Empty table.a                       ; Next line flushes buffers
      {Tools} {Info} {Family} Select table.a Delete "Family"
   ENDIF
   Return
ENDPROC
WriteLib libname.a EmptyTable.u
Release PROCS EmptyTable.u
?? ""
; ===========================================================================
;       Title - ErrorHandler.n
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;               Based upon a procedure by Alan Zenreich
;     Returns - Error Continuation Code
;  Chronology - Created: 05/07/90 02:41pm    Last revised: 01-11-91 09:23pm
; Description - Main Error Handling Procedure, calls ErrorLog.u
; ---------------------------------------------------------------------------
PROC ErrorHandler.n()
Private  caller.a,                     ; Proc that called ErrorHandler.n
         error.n,                      ; Error number
         errorproc,                    ; Keeps errorproc from being recursive
         errormsg.a,                   ; Error message
         errorwho.a,                   ; Contention User in MU setting
         msg.a,                        ; Formatted message to user
         script.a,                     ; Concatonated re-named Savevars.sc
         a                             ; Throw-away string from Match()

   error.n    = ErrorCode()
   errormsg.a = ErrorMessage()
   errorwho.a = ErrorUser()
   Canvas ON

   SWITCH
      CASE error.n = 43 OR errormsg.a = "Printer not ready" :
         PrintCheck.l()
         IF retval THEN
            ErrorReset.u()
            Return 0
         ENDIF
         Message.u("Attempting to Continue with Application",1,1)
         ErrorReset.u()
         Return 1
      CASE ErrorCode() = 27 :
         Message.u("Sorry, the Query could NOT be Completed",-1,0)
         ErrorReset.u()
         Return 1
      CASE (error.n = 3 OR error.n = 4)
       AND sysmode() = "DataEntry" :
         {KeepEntry}                      ; save in entry table(s)
         Message.u("Table locked by: " +errorwho.a+ " - Entries were Saved, Call Dan Paolini",-1,0)
         Return 2
   ENDSWITCH

   IF NOT Match(errormsg.a,"..Run Error..",a,msg.a) THEN
      IF NOT Match(errormsg.a,"..Syntax Error..",a,msg.a) THEN
            msg.a = errormsg.a
      ENDIF
   ENDIF

   ; proc.a the name of the Application procedure last called
   ; uproc.a is the of the current Utility procedure, if any
   ; caller.a *should* be the current procedure, either App or Utility

   IF NOT IsAssigned(proc.a) THEN   ; In case it is not assigned
      proc.a   = "***Not Available***"
   ENDIF

   IF NOT IsAssigned(uproc.a) THEN  ; In case it is not assigned
      uproc.a   = "Not Applicable"
      caller.a = proc.a
   ELSE
      caller.a = uproc.a
   ENDIF

   ; We don't use Beeper.u() or Message.u() because we might be low in
   ;  memory and unable to call another procedure.
   Beep Sleep 50 Beep Sleep 50 Beep
   Style ATTRIBUTE SysColor(3)      ; tell the user
      @ 0,0 ?? Format("w80,ac","Error in Procedure: " +caller.a)
      @ 1,0 ?? Format("w80,ac",msg.a)
      @ 2,0 ?? Fill("",80)
      @ 2,28 ?? " Hit any Key to Continue "
   Style
   retval = GetChar()               ; Wait for keypress
   ErrorLog.u()                     ; Log the error to disk and printer

   IF Version() >= 3 THEN           ; Paradox 2 has Savevars bug
      SaveVars ALL                  ; Rename Savevars.sc for posterity
      Run NOREFRESH "Copy " +PrivDir()+ "SaveVars.sc " +script.a
      Run NOREFRESH "Del " +PrivDir()+ "SaveVars.sc"

      IF PrinterStatus() THEN          ; Lets print the savevars.sc
         Run NOREFRESH "Copy " +script.a+ ".SC LPT1: > NUL"
         Open PRINTER
         Print
               "\f"                    ; Formfeed
         Close PRINTER
      ENDIF
   ENDIF
   IF Lower(cfgtable.a = "d\\ddemocfg") THEN
      Return 1                         ; Continue - for purposes of Demo
   ELSE
      Return 2
   ENDIF
ENDPROC
WriteLib libname.a ErrorHandler.n
Release PROCS ErrorHandler.n
?? ""
; ===========================================================================
;       Title - ErrorLog.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;               Based on a procedure by Alan Zenreich
;     Returns - no value
;  Chronology - Created: June, 1987     Last revised: 01-11-91 09:23pm
; Description - Error Logging Procedure called by ErrorHandler.u()
; ---------------------------------------------------------------------------
PROC ErrorLog.u()
Private  date.d,                       ; current date
         dir.a,                        ; current directory
         drive.n,                      ; current drive free space
         field.a,                      ; field name (if applicable)
         fieldvalue.v,                 ; current field value (if applicable)
         file.a,                       ; name of errorlog file
         formview.l,                   ; in FormView? (if applicable)
         image.a,                      ; image type (if applicable)
         memleft.n,                    ; free memory for procs and variables
         nimages.n,                    ; # of images on the workspace
         nrecords.n,                   ; number of table records (if applicable)
         privd.n,                      ; Private uproc.a, directory free space
         prnstatus.l,                  ; Is printer ready?
         record.n,                     ; current record # (if applicable)
         runtime.l,                    ; is this Paradox Runtime?
         shared.l,                     ; is current table shared? (if applicable)
         smem.n,                       ; startup MemLeft(), if mem.n assigned
         sysmode.a,                    ; system mode  (EDIT,MAIN, etc)
         table.a,                      ; table name (if applicable)
         time.a,                       ; current time
         version.n,                    ; Paradox Version
         d,h,m,s

   Message.u("An Error has occurred, please wait while it is logged",3,3)

   IF Version() >= 3 THEN              ; Version 2 has a SaveVars bug
      ; Parse the time to create a script name that consists of one or two
      ;  digit day of month, two digit hour, two digit minute, and two digit
      ;  second, like so: DDHHMMSS.sc - this allows saving SAVEVARS scripts
      ;  for a month without risking overwriting
      retval = Match(Time(),"..:..:..",h,m,s)
      IF Day(Today()) < 10 THEN
         d = "0" + StrVal(Day(Today()))
      ELSE
         d = StrVal(Day(Today()))
      ENDIF

      script.a = d+h+m+s
      IF DirExists("ERR") = 1 THEN
         script.a = "ERR\\" + script.a
      ENDIF                           ; now let's log what we know
   ENDIF

   date.d      = Today()
   dir.a       = Directory()
   drive.n     = DriveSpace(SubStr(dir.a,1,1))
   memleft.n   = MemLeft()
   privd.n     = DriveSpace(SubStr(PrivDir(),1,1))
   prnstatus.l = Format("LO",PrinterStatus())
   runtime.l   = Format("LY",IsRunTime())
   sysmode.a   = SysMode()
   time.a      = Time()
   version.n   = Version()

   IF NImages() <> 0 THEN                  ; occurred on image on workspace
      nimages.n    = NImages()
      table.a      = Table()
      image.a      = ImageType()
      field.a      = Field()
      fieldvalue.v = []
      shared.l     = IsShared(table.a)

      IF image.a   = "Query" THEN
         IF CheckMarkStatus() <> "" THEN ; store checkmark if appropriate
            fieldvalue.v = CheckMarkStatus()+" "+field.a
         ENDIF
      ENDIF
      nrecords.n   = NRecords(TABLE())

      IF ImageType() <> "Query" THEN
         formview.l = FORMAT("LN",IsFormView())
         record.n   = RECNO()
      ELSE
         formview.l = "N/A"
         record.n   = "N/A"
      ENDIF
   ELSE                                    ; not in an image
      nimages.n    = "N/A"
      table.a      = "N/A"
      image.a      = "N/A"
      shared.l     = "N/A"
      field.a      = "N/A"
      nrecords.n   = "N/A"
      formview.l   = "N/A"
      record.n     = "N/A"
      fieldvalue.v = "N/A"
   ENDIF

   IF IsAssigned(mem.n) THEN
      smem.n = mem.n
   ELSE
      smem.n = "N/A"
   ENDIF

   IF NOT IsAssigned(mainmenu.a) THEN
   mainmenu.a = "???MainMenu???"
   ENDIF

   IF NOT IsAssigned(submenu.a) THEN
   submenu.a = "No SubMenu"
   ENDIF

   IF errorwho.a = "" THEN
      errorwho.a = "N/A"
   ENDIF

   IF DirExists("ERR") = 1 THEN
      file.a = "err\\errorlog.sc"       ; appends to the error directory
   ELSE
      file.a = "errorlog.sc"       ; appends to the current directory
   ENDIF

   Print FILE file.a
"\n\n" ,                            ; "\n" = linefeed, "\t" = tab
"*** Error while in Procedure ", caller.a, " ***","\n",
"    ", mainmenu.a, "->", submenu.a, "->", proc.a, "\n",
"          Error: #", error.n ," - ", errormsg.a ,"\n",
" ------------------------------------------------------------------------","\n",
"           Date: ", date.d,    " \t",    "          Time: ", time.a ,      "\n",
"        Version: ", version.n, "  \t \t","       Runtime? ", runtime.l,    "\n",
"    Memory left: ", memleft.n, " \t \t", "Startup Memory: ", smem.n,       "\n",
;" SetSwap Amount: ", swap.n,    " \t \t", " Color Display? ", color.l,      "\n",
"        Sysmode: ", sysmode.a, " \t \t", "      Formview? ", formview.l,   "\n",
"        Nimages: ", nimages.n, " \t \t", "    Image Type: ", image.a,      "\n",
"       Nrecords: ", nrecords.n," \t \t", "       Record # ", record.n,     "\n",
"          Table: ", table.a,   " \t \t", "        Shared? ", shared.l,     "\n",
"  PrivDir Space: ", privd.n,   " \t \t", " CurrDir Space: ", drive.n,      "\n",
"      Directory: ", dir.a,     "\n",
"      Locked By: ", errorwho.a,    "\n",
"     Field name: ", field.a,       "\n",
"    Field Value: ", fieldvalue.v,  "\n",
" Printer Status: ", prnstatus.l,   "\n",
" ------------------------------------------------------------------------- ","\n"

   IF PrinterStatus() THEN                 ; prints log if printer is available
      Open PRINTER
      Print
"\n\n" ,                            ; "\n" = linefeed, "\t" = tab
"*** Error while in Procedure ", caller.a, " ***","\n",
"    ", mainmenu.a, "->", submenu.a, "->", proc.a, "\n",
"          Error: #", error.n ," - ", errormsg.a ,"\n",
" ------------------------------------------------------------------------","\n",
"           Date: ", date.d,    " \t",    "          Time: ", time.a ,      "\n",
"        Version: ", version.n, "  \t \t","       Runtime? ", runtime.l,    "\n",
"    Memory left: ", memleft.n, " \t \t", "Startup Memory: ", smem.n,       "\n",
;" SetSwap Amount: ", swap.n,    " \t \t", " Color Display? ", color.l,      "\n",
"        Sysmode: ", sysmode.a, " \t \t", "      Formview? ", formview.l,   "\n",
"        Nimages: ", nimages.n, " \t \t", "    Image Type: ", image.a,      "\n",
"       Nrecords: ", nrecords.n," \t \t", "       Record # ", record.n,     "\n",
"          Table: ", table.a,   " \t \t", "        Shared? ", shared.l,     "\n",
"  PrivDir Space: ", privd.n,   " \t \t", " CurrDir Space: ", drive.n,      "\n",
"      Directory: ", dir.a,     "\n",
"      Locked By: ", errorwho.a,    "\n",
"     Field name: ", field.a,       "\n",
"    Field Value: ", fieldvalue.v,  "\n",
" Printer Status: ", prnstatus.l,   "\n",
" ------------------------------------------------------------------------- ","\n"
      Close PRINTER
   ENDIF
Return
ENDPROC
WriteLib libname.a ErrorLog.u
Release PROCS ErrorLog.u
?? ""
; ===========================================================================
;       TITLE: ErrorReset.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;              Based upon ideas from Tim Colling and Dan Ehrmann
;     CREATED: 01-27-91 10:53:08pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC ErrorReset.u()
Private  uproc.a,                      ; Name of current procedure
         errorproc,
         v
   uproc.a = "ErrorReset.u"
   PROC TempError.n()
      Return 1                         ; skip statement causing error
   ENDPROC
   errorproc = "TempError.n"           ; temporary errorproc
   v = 1
   v = v + "hi"                        ; errorcode()=30 "data type mismatch"
   Release PROCS TempError.n
ENDPROC
WriteLib libname.a ErrorReset.u
Release PROCS      ErrorReset.u
?? ""
; ===========================================================================
;       TITLE: Family.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 09:14:53pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION: Restores Family Members to Application Tables.  It references
;              a "Tablist" table from the "BAK" directory.
; ---------------------------------------------------------------------------
PROC Family.u()
Private  uproc.a,                      ; Name of current procedure
         rec.n,                        ; Number of tables
         n,                            ; Counter
         tables.r,                     ; Array for table names
         path.r                        ; Array for Path names
   uproc.a = "Family.u"
   IF NOT DirExists("Bak") = 1 OR NOT IsTable("Bak\\tablist") THEN
      Message.u("The TABLIST Table is missing from the BAK Directory",-1,0)
      Return
   ENDIF
   IF IsEmpty("Bak\\tablist") THEN
      Message.u("The TABLIST Table is Empty - Please contact support",-1,0)
      Return
   ENDIF

   View "Bak\\tablist"
   MoveTo [Name]
   rec.n = NImageRecords()
   Array tables.r[rec.n]
   Array path.r[rec.n]

   SCAN
      tables.r[RecNo()] = []
      path.r[RecNo()] = [Path]
   ENDSCAN

   SetDir Directory()
   ClearAll
   For n From 1 To rec.n
      Message.u("Recovering Family for Table #" +StrVal(n)+ " of " +
                 StrVal(rec.n)+ " Tables",1,0)
      {Tools} {Copy} {JustFamily} Select "BAK\\"   + tables.r[n]
                                  Select path.r[n] + tables.r[n] {Replace}
   ENDFOR

   SetDir Directory()
   Message.u("Family Recovery is finished",3,1)
   Return
ENDPROC
WriteLib libname.a Family.u
Release PROCS      Family.u
?? ""
; ===========================================================================
;       Title - FieldView.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - no value
;  Chronology - Created: June, 1989     Last revised: 01-11-91 09:28pm
; Description - Generic Field View, traps for potential pitfalls of Fieldview
; ---------------------------------------------------------------------------
PROC FieldView.u()
Private uproc.a
   uproc.a = "FieldView.u"
   SWITCH
      CASE IsBlank([])    :
         Message.u("Field is empty",1,2)
      CASE Field() = "#"
         AND RecNo() > 65535:
         Message.u("Cannot use FieldView beyond Record #65535",1,2)
      OTHERWISE:
         FieldView
         PopBox.u(10,"Remember to Hit [Enter] to Finish the Field View",1,79,3)
         WHILE true                              ; set up wait loop
            Wait Field Prompt
" Using Field View...    Use Cursor -- Keys to Move within Field",
" Press [Enter] to Exit Field View"
            Until "Dos", "DosBig", "Help", "Enter"

            SWITCH
               CASE retval = "Enter"   : QUITLOOP
               CASE retval = "Help"    :
                  HelpMenu.u("FieldView")
                  Clear
               OTHERWISE               : Beep
            ENDSWITCH
         ENDWHILE
   ENDSWITCH
   Return
ENDPROC
WriteLib libname.a FieldView.u
Release PROCS FieldView.u
?? ""
; ===========================================================================
;       Title - GetInput.v
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - Value entered or false if [Esc] was hit
;  Chronology - Created: May, 1989    Revised: 01-08-91 10:39pm
; Description - Generic procedure for getting data input from user, with or
;               without validation.
; ---------------------------------------------------------------------------
PROC GetInput.v(top.n,              ; Top Row for Box
                prompt.a,           ; Data Input Prompt
                type.a,             ; type of Data Input
                valid.a)            ; additional validity string
Private  uproc.a,                   ; Name of this procedure
         input.v                    ; Value entered by user

uproc.a = "GetInput.v"
SWITCH
   CASE type.a = "D" : length.n = 12
   CASE type.a = "N" : length.n = 18
   CASE type.a = "C" : length.n = 18
   CASE type.a = "S" : length.n = 6
   OTHERWISE         : length.n = NumVal(SubStr(type.a,2,3))
ENDSWITCH

WHILE true
   Canvas OFF
   PaintCanvas FILL " "  top.n, 16, top.n+6, 63
   @ top.n, 16   ?? "ͻ"
   @ top.n+1, 16 ?? "                                              "
   @ top.n+2, 16 ?? "Ķ"
   @ top.n+3, 16 ?? "                                              "
   @ top.n+4, 16 ?? "Ķ"
   @ top.n+5, 16 ?? "       Press [Esc] to Cancel and Return       "
   @ top.n+6, 16 ?? "ͼ"

   IF Upper(SubStr(valid.a,1,7)) = "DEFAULT" THEN
      @ top.n+5, 16 ?? "[Esc]-Cancel [Enter]-Accept [BackSpace]-Change"
   ENDIF

   PaintCanvas ATTRIBUTE SysColor(3) top.n, 16, top.n+6, 63
   PaintCanvas ATTRIBUTE 8  top.n+1, 64, top.n+6, 65
   PaintCanvas ATTRIBUTE 8  top.n+7, 18, top.n+7, 65
   PaintCanvas ATTRIBUTE 15 top.n+3, 18, top.n+3, 61
   IF color.l THEN
      Style ATTRIBUTE 78
   ELSE
      Style ATTRIBUTE SysColor(3)
   ENDIF
   @ top.n+1, 18 ?? Format("w44,ac",prompt.a)
   Style ATTRIBUTE 15
   @ top.n+3, 18+Int((44-length.n)/2)
   Canvas ON
   Cursor NORMAL

   IF valid.a = "" THEN
      Accept type.a TO input.v
   ELSE
      SetSwap (2 * swap.n)                ; Free up some memory
      SetSwap swap.n                      ; Restore original swap point
      Execute "Accept type.a " +valid.a+ " TO input.v"
   ENDIF

   Cursor OFF
   IF NOT retval THEN
      Message.u("C",1,1)
      Return false
   ELSE
      Return input.v
   ENDIF
ENDWHILE
ENDPROC
WriteLib libname.a GetInput.v
Release PROCS GetInput.v
?? ""
; ===========================================================================
;       Title - HelpMenu.u
;      Author - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: August, 1989    Revised - 01-11-91 09:06pm
; Description - This is the main engine script for Help.  It displays the
;               context help screen (if any) and then presents a menu of
;               additional help choices until the User presses {Return}.
;               Context may be indicated in the calling proc explicitly,
;               or based on the variable assigned to the current menu
;               choice (the way I normally do it).  To not display a
;               specific screen, assign a blank string ("") to the formal
;               parameter.  To display the application's description,
;               assign the value of "APP_HELP" to the formal parameter.
;               The ErrorProc traps for missing help procs, and defaults to
;               the APP_HELP information screen.
; ---------------------------------------------------------------------------
PROC HelpMenu.u(helpchoice.a)           ; Initial Context for Help, or false,
                                        ;   later set by Help Menu selection
Private errorproc, quit.l, uproc.a, menu.a, flag.l
   uproc.a = "HelpMenu.u"
   flag.l = false
   PROC HelpErrorProc.u()                ; In case the desired procedure
   Private errorproc                     ;  is not defined, it defaults to
      IF ErrorCode() = 34 THEN          ;  the App_Help procedure, which
         helpchoice.a = "APP_HELP"     ;  _better_ be defined, or crash!
         menu.a = "APP_HELP"
         IF flag.l THEN
            ErrorHandler.n()
         ELSE
            ErrorReset.u()
            flag.l = true
            Return 0
         ENDIF
      ENDIF
      ErrorHandler.n()
   ENDPROC
   errorproc = "HelpErrorProc.u"
   quit.l = false                            ; Whether we want to Return
   WHILE true
      @ 2,0
      Canvas OFF                            ; hide the elves work and color screen
      PaintCanvas FILL " " ATTRIBUTE SysColor(8) 2,0,24,79
      ExecProc helpchoice.a + "Help.u"      ; All procs are named CONTEXTHelp.u
      IF quit.l THEN
         QUITLOOP
      ENDIF

      SHOWMENU
         "RETURN"    : "Return to where You were before HELP",
         "CUSTOM"    : "Additional Custom Help for this Application",
         "MENUS"     : "How to Use the Menus",
         "KEYBOARD"  : "How to Use the Keyboard Commands",
         "QUICK"     : "Quick Keyboard Reference",
         "ASK"       : "How to Use Queries",
         "PICKLISTS" : "How to Select a Record for Processing",
         "SEARCH"    : "How to Locate a Specific Record",
         "DITTO"     : "How to Use the Ditto Command - [Ctrl+D]",
         "FIELDEDIT" : "How to Use the Field Edit Command - [Ctrl+F]"
      To helpchoice.a

      IF NOT retval                       ; [Esc] was pressed
      OR helpchoice.a = "RETURN" THEN
         QUITLOOP
      ENDIF
   ENDWHILE                                ; Loop back, display new screen
Release PROCS HelpErrorProc.u
Return
ENDPROC
WriteLib libname.a HelpMenu.u
Release PROCS HelpMenu.u
?? ""
; ---------------------------------------------------------------------------
;       Title - PaintHelp.u
;      Author - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: November, 1989    Revised: 01-11-91 09:07pm
; Description - Standard Exploding window Coloring for Help Menus.  I have
;               seen exploding window routines that are very generic, and
;               hence, calculation intensive.  This routine is designed
;               specifically for my full-screen help screens.  It is very
;               simple.  Put the test on the screen, make it invisible by
;               using the same foreground and background color (17).  Then,
;               incrementally paint the expanding box the help screen color
;               (112), which "reveals" the "invisible" text!  You may want
;               to adjust the sleep or the colors to your environment.  This
;               is one time, however, when I am content to use a hard-coded
;               routine.  It works!  If it wasn't for the Sleep statements,
;               it would be too fast.
; ---------------------------------------------------------------------------
PROC PaintHelp.u()
    PaintCanvas ATTRIBUTE (Int(SysColor(8)/16) * 17)  2, 0,24,79 ; Make text invisible
    Canvas ON                             ; Turn canvas on so we see effect
    PaintCanvas ATTRIBUTE SysColor(8) 12,36,13,43 ; Gradually reveal the text
    Sleep 100
    PaintCanvas ATTRIBUTE SysColor(8) 11,32,14,47
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8) 10,29,15,50
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8)  9,25,16,54
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8)  8,22,17,57
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8)  7,18,18,61
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8)  6,15,19,64
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8)  5,11,20,68
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8)  4, 8,21,71
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8)  3, 4,22,75
    Sleep 20
    PaintCanvas ATTRIBUTE SysColor(8)  2, 0,24,79 ; Finished expanding
    PaintCanvas ATTRIBUTE SysColor(3)  2,11, 2,68 ; Exit msg in white on red
    PaintCanvas ATTRIBUTE 116  4, 1,24, 1 ; bullets in red on grey
ENDPROC

WriteLib libname.a PaintHelp.u
Release PROCS PaintHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - KeyboardHelp.u
;     Authors - (c) 1991 - Zenreich, Kocis, Paolini
;     Returns - No Value
;  Chronology - Created: 02/24/90 04:31pm    Revised: 01-11-91 08:56pm
; Description - Help for Paradox Keyboard - most text in revised version has
;               been borrowed from the equivalent screen in Wait Plus Pro.
;               Used with permission.
; ---------------------------------------------------------------------------
PROC KeyboardHelp.u()

Text
                        Help on Using the Keyboard             
            
        [Left] Previous field left         [Home] First record
       [Right] Next field right       [Ctrl+Home] First field of form or table
          [Up] Next field up                [End] Last record
        [Down] Next field down         [Ctrl+End] Last field of form or table
        [PgDn] Next screen down            [PgUp] Next screen up
   [Ctrl+PgDn] Next record            [Ctrl+PgUp] Previous record
  [Ctrl+Right] Next screen right      [Ctrl+Left] Previous screen left
  
         [Esc] Exits table or menu           [F1] Field help if available
          [F3] UpImage                       [F4] DownImage
          [F7] FormToggle                   [F10] Gets menu if available
   [Backspace] Deletes to left   [Ctrl+Backspace] Delete field
      [Ctrl+Z] Zoom to first value        [Alt+Z] Zoom to the next value
      [Ctrl+D] Usually Dittos (copies field from previous record)
  
  To allow cursor movement within field (FieldView) press [Ctrl+F] or [Alt+F5]
                    Cursor pad keys while in FieldView 
        [Left] Previous character          [Home] First character in field
       [Right] Next character               [End] Last character in field
  [Ctrl+Right] Next word right              [Del] Deletes character at cursor
   [Ctrl+Left] Prev word left               [Ins] Toggles insert mode on/off
EndText
PaintHelp.u()                           ; standard menu colors

ENDPROC

WriteLib libname.a KeyboardHelp.u
Release PROCS KeyboardHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - QuickHelp.u
;      Author - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;              Based upon an idea from Ed's Procs (author name misplaced)
;     Returns - No Value
;  Chronology - Created: November, 1989    Revised: 01-11-91 08:56pm
; Description - This used to be the Keyboard help screen before WPP.
; ---------------------------------------------------------------------------
PROC QuickHelp.u()

Text
                         Keyboard Quick Reference              
            
ͻ
         Function Key Commands                 Other Keyboard Commands       
Ķ
 Ŀ               Ŀ                [Esc] - Cancel Current Menu Choice 
 F1  Help Key      F2  Continue or       and/or Return to Previous Menu  
                 Selection Key ͹
 Ŀ               Ŀ                Use these Keys with the [Ctrl] Key 
 F3  Up Image      F4  Down Image    Ķ
                                [D] {Ditto} - Duplicate the Value  
 Ŀ               Ŀ                   in the Previous Record's Field  
 F5  [Alt]         F6                 [F] {FieldView/Edit} - View/Edit   
  FieldView                        within the Field contents       
 Ŀ               Ŀ                [BackSpace] - Erase Current Field  
 F7  Form Toggle   F8                 [Z] {Zoom} - Locate Matching Value 
                                [Alt+Z] {ZoomNext} - Locate Next   
 Ŀ               Ŀ               ͹
 F9  Edit Key      F10 Menu Key       [Ins] - Insert a Record            
                                [Del] - Delete a Record            
͹
       Cursor Movment Keys   [--]   [PgUp]   [PgDn]   [Home]   [End]       
ͼ
EndText
; the Keyboard Quick Reference is the only core help proc with custom colors
    PaintHelp.u()
    PaintCanvas ATTRIBUTE 127  5, 1, 5,41        ; Section titles white on grey
    PaintCanvas ATTRIBUTE 127  5,43, 5,78        ; Section titles white on grey
    PaintCanvas ATTRIBUTE 127 10,43,10,78        ; Section titles white on grey
    PaintCanvas ATTRIBUTE 127 23, 1,23,78        ; Section titles white on grey
ENDPROC

WriteLib libname.a QuickHelp.u
Release PROCS QuickHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - PickListsHelp.u
;      Author - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: November, 1989    Revised: 01-11-91 08:55pm
; Description - I use the Point and Shoot method for selecting a Master
;               record to work with.  This avoids having to ask the User
;               for input and possibly having a typo or value not found.
; ---------------------------------------------------------------------------
PROC PickListsHelp.u()

Text
                  Help on Selecting Items for Processing       
            

   You will first be presented with a list of Records from which to choose.
    Find the Record with which you wish to work and Press [F2] while the
    Cursor "_" is within that record.  Press [Esc] to Return to the MAIN MENU.

   To locate a Record quickly, place the Cursor in the field to be searched
    and Press [Ctrl+Z] to "Zoom".  At the prompt, enter the value and Press
    [Enter].  For Names, [Alt+Z] will locate the "next" name, if any.  You
    must type the value in the appropriate case, unless you use the pattern
    operator.

   You can search for a pattern by substituting the pattern operator (two
    periods "..") for the part of the value you do not know (i.e. SMI.. will
    locate all the values that begin with "SMI", such as SMITH, smile, or
    Smithereens).  ZOOM is not Case Sensitive when using the Pattern operator.

   The Prompt may advise you that you can Enter a new Record if it is not on
    the list that you have been presented.  In that case, Press [Ins] to add.

EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a PickListsHelp.u
Release PROCS PickListsHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - MenusHelp.u
;     Authors - (c) 1991 - Zenreich, Kocis, Paolini
;     Returns - No Value
;  Chronology - Created: September, 1989    Revised: 09/13/90 10:17am
; Description - Describes how to work with Menus.  This is from the WaitPlus
;               Pro Menu Help text.  Used with permission.
; ---------------------------------------------------------------------------
PROC MenusHelp.u()

Text
                         Help on Using the Menus               
            

    A menu presents you with a list of options available at any given point.
    Each menu choice has a descriptive line attached to it.  To use Menus:
    

   Press the first letter of the menu selection.  If there is more than one
    choice beginning with the first letter, you will be asked to select from
    those that begin with that letter.

   Use [Left] or [Right] arrow keys to highlight the menu choice, then press
    [Enter].  When menu choice is highlighted, it displays descriptive prompt.

   To escape from the menu, returning to whatever you were doing before you
    selected it, press [Esc].
    
    Special keys:     [F1]  Displays Additional Help (if available).
                    [Home]  Moves to first menu selection.
                     [End]  Moves to last menu selection.
                    [Down]  Moves right one screen (if available).
                      [Up]  Moves left one screen (if available).
EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a MenusHelp.u
Release PROCS MenusHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - SearchHelp.u
;      Author - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, inc.
;     Returns - No Value
;  Chronology - Created: 07/15/90 12:19pm    Revised: 01-11-91 08:52pm
; Description - Describes how to work with the Locate Menu.
; ---------------------------------------------------------------------------
PROC SearchHelp.u()

Text
                         Help on Locating Records              
            
                   There are several ways to Search for Data

    While in a Table
   [Home] moves to the first record in table, [End] moves to the last one.
   The Cursor  Keys and [PgUp] and [PgDn] move between Records.
    While at the Locate Menu
   INCREMENTAL - Perform incremental Search, one character at a time.
   FUZZY       - Perform a fuzzy Search, as in a "LIKE" Query.
   ZOOM        - Search for a Value or Pattern (see [Ctrl+Z] below).
   LOCATE      - Search on the first several Fields of a Table.
   ADHOC SCAN  - Search for values in any combination of Fields.
   RECORD MOVE - Move to specified Record Number in the Table.
   FUZZY, ZOOM and LOCATE all have a NEXT option, to Locate the Next
    Record that meets the criteria of the last relevent Search.
    While using Zoom
   [Ctrl+Z] Zooms to the first occurrence of a value for the current field.
   Enter EXACT value (case sensitive) or Use wildcards (not case sensitive).
   The wildcards are:      @ - one character      .. - String of characters
   Leave zoom blank for first blank value.
   [Alt+Z] or ZOOM-NEXT finds the next occurrence of the last zoom value.
EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a SearchHelp.u
Release PROCS SearchHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - DittoHelp.u
;      Author - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: 02/01/90 02:31pm    Revised: 09/13/90 10:17am
; Description - Description on how to use the Ditto command
; ---------------------------------------------------------------------------
PROC DittoHelp.u()

Text
                  Help on Using the DITTO Key - [Ctrl+D]       
            

   The Ditto Key [Ctrl+D] will duplicate the value of the current field from
    the previous record, and place it in the current field of the current
    record.  The current field must be empty.

   This is easy to understand in Table View or when working in Multi-Record
    Forms.  The value is copied from the record above the current record.

   It also works while in single record Form View.  You do not need to see
    the record that is being copied.  It will duplicate a value from the
    previous record, even when that record is not being displayed.

   The field that in which you want to place the duplicate value must be
    empty before you press [Ctrl+D].  If it is not, you can press [Ctrl+
    BackSpace] to erase the entire field first.
EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a DittoHelp.u
Release PROCS DittoHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - FieldEditHelp.u
;      Author - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: 02/01/90 02:33pm    Revised: 01-11-91 08:54pm
; Description - Description on how to use the FieldView command
; ---------------------------------------------------------------------------
PROC FieldEditHelp.u()

Text
                    Help on Using Field View - [Ctrl+F]        
            

   The Field View Key [Ctrl+F] (or alternately [Alt+F5]) allows you to work
    within the current field.  While this is principally used for Editing,
    Field View also works when Viewing information.

   Without Field View, if you have a field consisting of many characters,
    and you need to make a correction to the first character, you will have
    to backspace over the trailing characters to get to the first character.
    In effect, you will be erasing all of the subsequent characters.

   With Field View, after hitting [Ctrl+F], you can use the Cursor Keys
    [-] [-] [Home] [End] to move within the field contents without erasing
    any of the information.

   You can use [Del] to Delete the character at the cursor, [Ins] to toggle
    between Insert/OverStrike, [Ctrl+-] to move one word to the right, and
    [Ctrl+-] to move one word to the left.

   You must press [Enter] or [F2] to end Field View, before control is
    returned to normal record movement.
EndText
PaintHelp.u()

ENDPROC

WriteLib libname.a FieldEditHelp.u
Release PROCS FieldEditHelp.u
?? ""
; ===========================================================================
;       TITLE: AskHelp.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 03-02-91 01:39:34pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC AskHelp.u()
Text
                           Help on Using Queries               
            

   The Field View Key [Ctrl+F] (or alternately [Alt+F5]) allows you to work
    within the current field.  While this is principally used for Editing,
    Field View also works when Viewing information.

   Without Field View, if you have a field consisting of many characters,
    and you need to make a correction to the first character, you will have
    to backspace over the trailing characters to get to the first character.
    In effect, you will be erasing all of the subsequent characters.

   With Field View, after hitting [Ctrl+F], you can use the Cursor Keys
    [-] [-] [Home] [End] to move within the field contents without erasing
    any of the information.

   You can use [Del] to Delete the character at the cursor, [Ins] to toggle
    between Insert/OverStrike, [Ctrl+-] to move one word to the right, and
    [Ctrl+-] to move one word to the left.

   You must press [Enter] or [F2] to end Field View, before control is
    returned to normal record movement.
EndText
PaintHelp.u()
ENDPROC
WriteLib libname.a AskHelp.u
Release PROCS      AskHelp.u
?? ""
; ---------------------------------------------------------------------------
;       Title - HilightRecord.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: 12/04/90 01:15:21am    Revised: 01-11-91 09:32pm
; Description - Highlights current record in Table or Form view
; ---------------------------------------------------------------------------
PROC HilightRecord.u()
Private uproc.a
   uproc.a = "HilightRecord.u"
   Canvas OFF
   Echo NORMAL
   Echo OFF
   Canvas ON
   SyncCursor
   IF IsFormView() THEN
      Style ATTRIBUTE SysColor(3) + 128
      ?? ""
      Style
   ELSE
      PaintCanvas ATTRIBUTE SysColor(3) Row(),0,Row(),79
   ENDIF
   Return
ENDPROC
WriteLib libname.a HilightRecord.u
Release PROCS HilightRecord.u
?? ""
; ===========================================================================
;       Title - KeyConflict.u
;      Author - (c) 1991 - Daniel J. Paolini II, CMA
;     Returns - Logical true/false if conflict resolved
;  Chronology - Created: 09/25/90 10:51:07pm    Revised:
; Description -
; ---------------------------------------------------------------------------
PROC KeyConflict.l()
Private  uproc.a,
         n, r,
         popitems.r

   uproc.a = "KeyConflict.l"
   WHILE true
      Style ATTRIBUTE SysColor(3)
      @ 0,0 ?? Format("W80"," A Record with the same Key Value already Exists")
      @ 1,0 ?? Format("w80"," Please Resolve the Conflict between the Records")
      Style
      Array popitems.r[4]
         popitems.r[1] = "TOGGLE Duplicate"
         popitems.r[2] = "REPLACE Original"
         popitems.r[3] = "CANCEL New Record"
         popitems.r[4] = "EDIT New Record"
      n = MenuPop.n(0,56,"Resolve Conflict",64,79,31)
      SWITCH
         CASE n = 0 :
            Beep
         CASE n = 1 :
            KeyLookup
            Echo NORMAL Echo OFF
         CASE n = 2 :
            LockRecord
            QUITLOOP
         CASE n = 3 :
            Del Ins
         CASE n = 4 :
            CopyToArray r
            Del Ins
            CopyFromArray3.u("r", requiredcheck.l)
            QUITLOOP
         CASE n = 99:
            HelpMenu.u("CONFLICT")
      ENDSWITCH
   ENDWHILE
   Return (n = 2)
ENDPROC
WriteLib libname.a KeyConflict.l
Release PROCS KeyConflict.l
?? ""
