? " Utility2.sc"
@ Row(),13 ?? Fill("",17)
@ Row(),13
libname.a = "Utility"
IF NOT IsFile(libname.a + ".LIB") THEN
   CreateLib libname.a SIZE 100
ENDIF
; ===========================================================================
;       Title - LocateArray.l
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;               Based upon procedures by Joe Fusco and Steve Dickinson
;     Returns - No Value
;  Chronology - Created: 11/22/90 11:39:35pm    Revised:
; Description - Performs and incremental Zoom on the current Field.
;               Procedure exits with: [Enter]-Select   or: [Esc]-Cancel
; ---------------------------------------------------------------------------
PROC LocateArray.l()
Private uproc.a,
        menu.r,
        item.n,
        lastsearch.a,
        next.n,
        search.a,
        v,
        width.n,
        left.n,
        prompt1.a,
        a1, a2

   uproc.a = "LocateArray.l"
   IF NImageRecords() < 2 or ColNo() = 1 THEN
      Message.u("Sorry, you cannot Search in RecNo Field, or in 1-record Table",3,1)
      Return false                   ; Can't Zoom under these conditions
   ENDIF

   Home
   Canvas OFF
   width.n = 30
   IF SubStr(FieldType(),1,1) = "A" THEN
      width.n = NumVal(SubStr(FieldType(),2,3)) + 4
      width.n = Max(width.n,30)
      width.n = Min(width.n,72)
   ENDIF

   left.n = Int((79 - width.n)/2)
   IF Monitor() = "Color" THEN
      PaintCanvas ATTRIBUTE 8     7, left.n + 2, 22, left.n + width.n + 1
      Style ATTRIBUTE 47
   ELSE
      Style REVERSE
   ENDIF

   @  6,left.n ?? "" +Fill("",width.n-2)+ ""
   @ 21,left.n ?? "" +Fill("",width.n-2)+ ""
   a1 = "" +Fill(" ",width.n-2)+ ""
   a2 = "" +Fill("",width.n-2)+ ""
   @  7,left.n ?? a1
   @  8,left.n ?? a1
   @  9,left.n ?? a1
   @ 10,left.n ?? a1
   @ 11,left.n ?? a2

   prompt1.a = "Searching: " +Upper(Field())
   @ 7,Int((79-Len(prompt1.a))/2) ?? prompt1.a
   IF color.l THEN
      Style ATTRIBUTE 46
   ELSE
      Style REVERSE
   ENDIF
   @ 6,30 ?? "Incremental Search"
   @ 8,26 ?? "Highlight Record to Select"
   @ 9,26 ?? "Enter Characters to Locate"
   IF color.l THEN
      Style ATTRIBUTE 47
   ELSE
      Style INTENSE, REVERSE
   ENDIF

   WHILE CharWaiting()                 ; clear keyboard buffer
      retval = GetChar()               ; of any pending keystrokes
   ENDWHILE

   lastsearch.a = ""                   ; initialize keycode variable
   WHILE true                          ; LOOP TO TRAP KEYSTROKES:
      Canvas OFF
      @ 10,26 ?? "Searching For > " +Upper(lastsearch.a)+
                  Spaces(10 - Len(lastsearch.a))
      IF color.l THEN
         PaintCanvas ATTRIBUTE 32 10,26,10,40
         PaintCanvas ATTRIBUTE 10 10,41,10,52
      ELSE
         PaintCanvas REVERSE  10,41,10,52
      ENDIF
      next.n = LookupArrayMenu.a()     ;get next keycode value from keyboard
      SWITCH
         CASE next.n = 13              ; exit on [Enter] or [Esc] or [F2]
            OR next.n = 27
            OR next.n = -60   : QUITLOOP
         CASE next.n =  8:
            lastsearch.a = ""          ; loop on [BackSpace]
            Home                       ; to restart search
         OTHERWISE            :        ; concatenate symbols, then search
            IF Len(lastsearch.a) = 10 THEN
               Beep
               search.a = lastsearch.a
            ELSE
               search.a = lastsearch.a + Chr(next.n)
            ENDIF
            Locate NEXT PATTERN search.a + ".."
            lastsearch.a = search.a ; reset stored keycode values
      ENDSWITCH

   ENDWHILE                            ; END OF KEY TRAPPING LOOP

   l = false
   IF next.n = 13 OR next.n = -60 THEN ; process [F2/Enter] (value selected)
      Locate menu.r[Row()-11]
      l = retval
   ENDIF
   IF l THEN
      HilightRecord.u()
      Sleep 1000
   ENDIF
   Return l
ENDPROC
WriteLib libname.a   LocateArray.l
Release PROCS        LocateArray.l
?? ""
; ===========================================================================
;       Title - LocateLike.l
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - Logical true/false if Match found
;  Chronology - Created: 10/09/90 03:42:29pm    Revised: 12/02/90 05:11pm
; Description - Calls LocateLikeFirst/LocateLikeNext and reports results
;               Note that source.a and sens.s should be private to the
;               procedure that calls LocateLike.l, or else should be
;               explicitly released when the session is ended.
; ---------------------------------------------------------------------------
PROC LocateLike.l(next.a)                 ; Is this FIRST or NEXT search?
Private  uproc.a,
         l,                               ; Logical true/false if match found
         rec.n                            ; Number of records in table - this
                                          ;   method needs to be adjusted for
                                          ;   multi-user access, to return to
                                          ;   the original record if no match
;global  source.a                         ; What to compare against
;        sens.s                           ; Sensitivity level (0, 1 or 2)

   uproc.a = "LocateLike.l"
   IF NOT SubStr(FieldType(),1,1) = "A" THEN
      Message.u("You must use this Procedure in an AlphaNumeric Field",3,1)
      Return false
   ENDIF

   rec.n = RecNo()
   IF Upper(next.a) = "NEXT" AND
      IsAssigned(source.a) AND
      IsAssigned(sens.s) THEN
         LocateLikeNext.a()
   ELSE
      LocateLikeFirst.a()
   ENDIF

   SWITCH
      CASE retval = "CANCEL"  :
         Message.u("C",3,1)
         l = false
      CASE retval = "NONE"    :
         Message.u("Match not found for " +source.a+ " with " +StrVal(sens.s)+
                     " discrepancies",3,1)
         l = false
      CASE retval = "NO MORE" :
         Message.u("No other matches found for " +source.a+ " with " +
                     StrVal(sens.s)+ " discrepancies",3,1)
         l = false
      OTHERWISE               :       ; Show us what we found
         HilightRecord.u()
         Message.u("The Value was Located",1,2)
         l = true
   ENDSWITCH

   IF NOT l THEN
      IF SysMode() = "Coedit" THEN    ; Need better way to return to
         Home                        ;   original record if no match
      ELSE
         MoveTo RECORD rec.n
      ENDIF
   ENDIF
   Return l
ENDPROC
WriteLib libname.a LocateLike.l
Release PROCS LocateLike.l
?? ""
; ===========================================================================
;       Title - LocateLikeFirst.a
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - "CANCEL", "FOUND", "NONE"
;  Chronology - Created: 10/09/90 03:42:03pm    Revised: 12/02/90 05:28pm
; Description - First time through, looking for LIKE match
; ---------------------------------------------------------------------------
PROC LocateLikeFirst.a()
Private  uproc.a,
         init.a,                         ; Initial character of search string
         length.n,                       ; Length of search string
         miss.n,                         ; Counter for missed characters
         n,                              ; Counter for FOR loops
         source.r,                       ; Array of characters in search string
         field.r,                        ; Array of characters in field string
         popitems.r
;Global  source.a,                       ; Search string
;        sens.s                          ; Sensitivity level (0-2), indicating
                                         ;   number of allowable misses
   uproc.a = "LocateLikeFirst.a"
   source.a = GetInput.v(8,"Enter String to Search For (Max Length = 24)",
                        "A24","")
   IF source.a = false OR IsBlank(source.a) THEN
      Return "CANCEL"
   ENDIF

   Array popitems.r[3]
      popitems.r[1] = "AVERAGE"
      popitems.r[2] = "MORE SENSITIVE"
      popitems.r[3] = "LESS SENSITIVE"
   PopBox.u(1,"Average = 1, More = 0, Less = 2 Discrepancies",2,79,0)
   WHILE true
      MenuPop.n(11,55,"Select Sensitivity",33,47,31)
      SWITCH
         CASE retval = 99  :
            HelpMenu.u("LOCATE")
            Echo NORMAL Echo OFF
            LOOP
         CASE retval = 2   : sens.s = 0
         CASE retval = 3   : sens.s = 2
         OTHERWISE         : sens.s = 1
      ENDSWITCH
      QUITLOOP
   ENDWHILE

   length.n = Len(source.a)
   source.a = Upper(source.a)
   init.a   = SubStr(source.a,1,1)
   Array source.r[length.n]
   Array field.r[length.n]
   FOR n From 1 To length.n
      source.r[n] = SubStr(source.a,n,1)
   ENDFOR

   SCAN FOR Upper(SubStr([],1,1)) = init.a
      AND (Len([]) + sens.s) >= length.n
      FOR n From 1 To Min(length.n,Len([]))
         field.r[n] = Upper(SubStr([],n,1))
      ENDFOR
      miss.n = 0
      FOR n From 1 to Min(length.n,Len([]))
         IF field.r[n] <> source.r[n]
         AND field.r[n] <> source.r[Max(1,n-1)]
         AND field.r[n] <> source.r[Min(length.n,n+1)] THEN
            miss.n = miss.n + 1
         ENDIF
      ENDFOR
      IF miss.n <= sens.s THEN
         Return "FOUND"
      ENDIF
   ENDSCAN
   Return "NONE"
ENDPROC
WriteLib libname.a LocateLikeFirst.a
Release PROCS LocateLikeFirst.a
?? ""
; ===========================================================================
;       Title - LocateLikeNext.a
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - "FOUND" or "NO MORE"
;  Chronology - Created: 10/09/90 03:41:41pm    Revised: 12/02/90 05:37pm
; Description - Checks for next LIKE value
; ---------------------------------------------------------------------------
PROC LocateLikeNext.a()
Private  uproc.a,
         init.a,                       ; Initial character of search string
         length.n,                     ; Length of search string
         miss.n,                       ; Counter for missed characters
         n,                            ; Counter for FOR loops
         source.r,                     ; Array of characters in search string
         field.r                       ; Array of characters in field string
;Global  source.a,                     ; Search string
;        sens.s                        ; Sensitivity level (0-2), indicating
                                       ;   number of allowable misses
   uproc.a = "LocateLikeNext.a"
   length.n = Len(source.a)
   source.a = Upper(source.a)
   init.a   = SubStr(source.a,1,1)
   Array source.r[length.n]
   Array field.r[length.n]

   FOR n From 1 To length.n
      source.r[n] = SubStr(source.a,n,1)
   ENDFOR

   WHILE true
      Skip
      IF EOT() THEN
         Return "NO MORE"
      ENDIF

      Locate NEXT PATTERN init.a + ".."
      SWITCH
         CASE NOT retval                     :  Return "NO MORE"
         CASE (Len([]) + sens.s) < length.n  :  LOOP
      ENDSWITCH

      FOR n From 1 To Min(length.n,Len([]))
         field.r[n] = Upper(SubStr([],n,1))
      ENDFOR

      miss.n = 0
      FOR n From 1 to Min(length.n,Len([]))
         IF field.r[n] <> source.r[n]
         AND field.r[n] <> source.r[Max(1,n-1)]
         AND field.r[n] <> source.r[Min(length.n,n+1)] THEN
               miss.n = miss.n + 1
         ENDIF
      ENDFOR

      IF miss.n <= sens.s THEN
         Return "FOUND"
      ENDIF
   ENDWHILE
   Return "NO MORE"
ENDPROC
WriteLib libname.a LocateLikeNext.a
Release PROCS LocateLikeNext.a
?? ""
; ===========================================================================
;       Title - LocateMenu.l
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;               Based upon an idea by Zenreich/Kocis
;     Returns - No Value
;  Chronology - Created: 11/23/90 10:44:53pm    Revised: 01-11-91 09:43pm
; Description - Menu driven record locate procedure, while in Display image
; ---------------------------------------------------------------------------
PROC LocateMenu.l()
Private  uproc.a,
         menu.a,
         item.n,
         a,
         key.n,
         records.a,
         rec.n,
         popitems.r

   uproc.a = "LocateMenu.l"
   IF NImageRecords() < 2 or ColNo() = 1 THEN
      Message.u("Sorry, you cannot Search in RecNo Field, or in 1-record Table",3,1)
      Return false                   ; Can't Search under these conditions
   ENDIF

   Array popitems.r[7]
   popitems.r[1] = "INCREMENTAL - Character by Character"
   popitems.r[2] = "FUZZY       - Similar/Like Search"
   popitems.r[3] = "ZOOM        - Paradox Zoom on Value"
   popitems.r[4] = "LOCATE      - On First 2 to 5 Fields"
   popitems.r[5] = "ADHOC SCAN  - User-Selected Fields"
   popitems.r[6] = "RECORD MOVE - Directly to Record #"
   popitems.r[7] = "HELP        - How to use Locate Menu"

   WHILE true
      item.n = MenuPop.n(0,0,"Choose Search Method for "+Field(),31,27,49)
      IF item.n = 99 THEN
         item.n = 7                    ; Help
      ENDIF
      SWITCH
         CASE item.n = 0  : retval = false
         CASE item.n = 1  : LocateArray.l()
         CASE item.n = 5  :
            Message.u("Sorry, LocateScan.l is still in Beta Testing and is unavailable",3,3)
         CASE item.n = 6  :
            records.a = StrVal(NImageRecords())
            rec.n = GetInput.v(9,"On Record #" +StrVal([#])+ " of " +records.a+
                                 " - Enter New Record #","N",
                                 "MIN 1 MAX " +records.a+ " PICTURE \"#[*#]\"")
            IF NOT retval = false THEN
               MoveTo RECORD rec.n
               HilightRecord.u()
               Message.u("The Value was Located",1,2)
            ENDIF
         CASE item.n = 7  :
            HelpMenu.u("Locate")
            Echo NORMAL Echo OFF
            LOOP
         OTHERWISE   :
            MenuPop2.l(item.n+2,38,"Select Method","NEW","REPEAT",
                      "Begin New Search","Repeat Last Search",33,47,31,false)
            IF NOT retval THEN
               a = "FIRST"
            ELSE
               a = "NEXT"
            ENDIF
            SWITCH
               CASE item.n = 2  : LocateLike.l(a)
               CASE item.n = 3  : Zoom.l(a)
               CASE item.n = 4  : LocateRecord.l(a)
               CASE item.n = 5  : LocateScan.l(a)
            ENDSWITCH
      ENDSWITCH
      Return retval
   ENDWHILE
ENDPROC
WriteLib libname.a   LocateMenu.l
Release PROCS        LocateMenu.l
?? ""
; ===========================================================================
;       Title - LocateRecord.l
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: 11/24/90 00:07:06am    Revised: 01-11-91 09:44pm
; Description - Locates match of first n Fields of table
; ---------------------------------------------------------------------------
PROC LocateRecord.l(type.a)            ; FIRST or NEXT
Private  uproc.a,
         fields.n,
         locate.r
   uproc.a = "LocateRecord.l"
   SWITCH
      CASE Upper(type.a) = "NEXT"
       AND IsAssigned(locate.r[1]):
         Skip                          ; Start with next record
         SWITCH
            CASE ArraySize(locate.r) = 2    :
               Locate NEXT locate.r[1], locate.r[2]
            CASE ArraySize(locate.r) = 3    :
               Locate NEXT locate.r[1], locate.r[2], locate.r[3]
            CASE ArraySize(locate.r) = 4    :
               Locate NEXT locate.r[1], locate.r[2], locate.r[3], locate.r[4]
            OTHERWISE           :
               Locate NEXT locate.r[1], locate.r[2], locate.r[3], locate.r[4],
                           locate.r[5]
         ENDSWITCH
      OTHERWISE                   :
         fields.n = GetInput.v(10,"Enter # of Fields to Locate (Min=2,Max=5)",
                              "S","MIN 2 MAX 5")
         IF retval = false OR IsBlank(fields.n) THEN
            Return
         ENDIF

         Array locate.r[fields.n]
         CopyToArray r
         FOR n From 1 To fields.n
            Echo NORMAL
            Echo OFF
            type.a = Type(r[n+1])
            IF SubStr(type.a,1,1) = "A" THEN
               type.a = "A40"
            ENDIF
            locate.r[n] = GetInput.v(0,"Enter Search Value for Field #" +StrVal(n),
                                     type.a,"")
            IF retval = false THEN
                  Return
            ENDIF
         ENDFOR

         SWITCH
            CASE fields.n = 2   :
               Locate locate.r[1], locate.r[2]
            CASE fields.n = 3   :
               Locate locate.r[1], locate.r[2], locate.r[3]
            CASE fields.n = 4   :
               Locate locate.r[1], locate.r[2], locate.r[3], locate.r[4]
            OTHERWISE           :
               Locate locate.r[1], locate.r[2], locate.r[3], locate.r[4],
                      locate.r[5]
         ENDSWITCH
   ENDSWITCH

   IF NOT retval THEN
      Message.u("No Record was Located for those Values - Is caSE Correct?",3,3)
      Release VARS locate.r
      Return false
   ENDIF
   HilightRecord.u()
   Message.u("The Value was Located",1,2)
   Return true
ENDPROC
WriteLib libname.a   LocateRecord.l
Release PROCS        LocateRecord.l
?? ""
; ===========================================================================
;       Title - LockTable.l
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - logical true/false if lock successful
;  Chronology - Created: 04/19/90 11:16pm
; Description - Generic lock table procedure using a lock string
;               I got tired of placing lock statements in my code.  The
;               difficulty is that the command has to be called by EXECUTE
;               in order to use a variable for the locktable string.  Since
;               Execute requires that backslashes be doubled, the variable
;               lock.a must be created with QUADRUPLE backslashes, and the
;               quotes around the tables must be preceded by a backslash,
;               like so:  lock.a = "\"d\\\\Table1\" PWL, \"d\\\\Table2\" WL"
;               As you can imagine, that makes writing the string difficult!
; ---------------------------------------------------------------------------
PROC LockTable.l(lock.a)        ; tables and locks to try
Private  uproc.a,
         lock.n

uproc.a = "LockTable.l"
lock.n = 0
WHILE true
   Message.u("Attempting to Lock the Necessary Tables",0,1)
   Execute "LOCK " + lock.a                ; using lock string
   IF retval THEN                          ; successful!
      Message.u("Table Locks were Successful!",0,0)
      Return true
   ENDIF

   IF lock.n < 5 THEN                      ; try 1 to 5 times in 5 seconds
      lock.n = lock.n + 1
      Sleep 1000
      LOOP
   ELSE                                    ; uh-oh
      Message.u("Lock(s) Failed: " +ErrorMessage(),-1,0)
      MenuPop2.l(3, 21, " Try Again to Lock it? ", "TRY_AGAIN", "STOP",
                "Try to Lock Table Again",
                "Stop Trying for Now",
                 47, 32, 15, true)
      IF retval THEN
         lock.n = 0                      ; reset loop counter
         Message.u("Trying Again",0,1)
         LOOP
      ELSE
         Message.u("C",1,1)              ; let's get out of here!
         Clear Return false
      ENDIF
   ENDIF
ENDWHILE
ENDPROC
WriteLib libname.a LockTable.l
Release PROCS LockTable.l
; ===========================================================================
; LookupAddForm.u       - allows insertion of records in embedded lookup form
; LookupArray.v         - variation of Zipmenu
; LookupArrayMenu.a     - used by LookupArray.v
; LookupArrayHilight.u  - used by LookupArrayMenu.a
; LookupHelpKey.u       - controls access to Custom Help and normal Table Lookup
; LookupSelect.n        - processes key presses in Lookup table for LookupHelp
; ===========================================================================
;       Title - LookupAddForm.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No value
;  Chronology - Created: December, 1989   Revised: 07/08/90 08:43am
; Description - Uses an unlinked, embedded form on another page of a form
;               to simulate a popup window for help.  This is accomplished by
;               placing a copy of the first page of the form, except that the
;               fields are all display-only.  To enable this, one regular
;               field from the master form must be on the second page.  This
;               field can be hidden by manipulating the screen attributes.
; ---------------------------------------------------------------------------
PROC LookupAddForm.u(helptable.a,          ; table to get Lookup Info
                     helpfield.a,          ; Key field name of Lookup table
                     edit.l)               ; Edit Lookup? true/false
Private  uproc.a,
         look.v,                       ; lookup value or false
         table.a,                      ; name of calling table
         field.a,                      ; name of calling field
         prompt2.a,                    ; second line of prompt
         l,
         r,
         n,
         blank.l,
         key.n,
         formview.l

   uproc.a = "LookupAddForm.u"
   table.a = Table()               ; where are we now?
   field.a = Field()
   IF NOT IsValid() THEN
      CtrlBackSpace             ; Clear the field.
   ENDIF
   oldimage.n = IMAGENO()
   CopyToArray r
   key.n = NKeyFields(Table())
   IF key.n > 0 THEN
      FOR n From 1 To key.n
         IF NOT IsBlank(r[n+1]) THEN
            blank.l = false
            QUITLOOP
         ENDIF
         blank.l = true                ; No need to save record - it's blank
      ENDFOR
   ENDIF

   IF blank.l THEN
      Del
   ENDIF
   Moveto helptable.a                  ; go to the helptable part of form
   Home                                ; Return to Top of Table
   ImageRights READONLY                ;    look but don't touch

   prompt2.a = " Press [F2] to Select Value    [Esc] to Cancel Lookup"
   IF edit.l THEN                      ; if we can edit
      prompt2.a = prompt2.a + "    [Ins] to Add Record"
   ENDIF

   WHILE true
      WAIT Table Prompt
   " Locating Lookup Value...    Search using [Ctrl+Z] to Locate",
   prompt2.a
      Until "Dos", "DosBig", "F35", "FieldView", "Zoom", "Ins", "Rotate",
            "Del", "F1", "F2", "Esc", -35

      SWITCH
         CASE retval = "F2"  :               ; assign value
            MoveTo FIELD helpfield.a
            look.v = []
            QUITLOOP
         CASE retval = "Esc" :               ; return without value
            look.v = false
            QUITLOOP
         CASE retval = "Ins"
          AND edit.l         :               ; if edit then insert new record
            ImageRights
            Ins
            WHILE true
               Wait RECORD Prompt
   " Adding New Lookup Record...",
   " Press [F2] to Add    [Esc] to Cancel"
               Until "Dos", "DosBig", "F35", "FieldView", "Zoom", "Rotate",
                     "Ins", "Del", "F2", "Esc", "F1", -35
               SWITCH
                  CASE retval = -35    : HelpMenu.u("Lookup")
                  CASE retval = "F2"  :
                     OkKey3.l(false)
                     IF NOT retval THEN
                        LOOP
                     ENDIF
                     MoveTo FIELD helpfield.a
                     look.v = []
                     l = true
                     QUITLOOP
                  CASE retval = "Esc" :
                     Del
                     l = false
                     QUITLOOP
                  OTHERWISE           : Beep
               ENDSWITCH
            ENDWHILE
            IF l THEN
               QUITLOOP
            ENDIF
            ImageRights READONLY
         CASE retval = "Zoom" :   LocateArray.l()
         CASE retval = "FieldView"
            OR retval = "F35" :   FieldView.u()
         CASE retval = "F1"   :   LookupHelpKey.u("Lookup")    ; get help!
         CASE retval = -35    :   HelpMenu.u("Lookup")
         OTHERWISE            :   Beep        ; illegal keys
      ENDSWITCH
   ENDWHILE

   ImageRights                         ; restore imagerights if needed
         MoveTo table.a        ; Back to the original table.
         MoveTo FIELD field.a
         IF blank.l OR NOT [] = r[field.a] THEN
            Ins
         ENDIF
   IF NOT look.v = false THEN
      [] = look.v                     ; assign value
   ENDIF
   Prompt
   Return
ENDPROC
WriteLib libname.a LookupAddForm.u
Release PROCS LookupAddForm.u
?? ""
; ===========================================================================
;       Title - LookupArray.v
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;               Based upon procedures by Joe Fusco and Steve Dickinson
;     Returns - No Value
;  Chronology - Created: 11/22/90 11:39:35pm    Revised: 01-11-91 09:46pm
; Description - This is like LocateArray, only it functions as a replacement
;               for Lookup Help.  [Enter]-Selects   [Esc]-Cancels.
; ---------------------------------------------------------------------------
PROC LookupArray.v(table.a,
                   field.a)
Private  uproc.a,
         curfield.a,
         curtable.a,
         item.n,
         lastsearch.a,
         left.n,
         menu.r,
         nextchar.n,
         search.a,
         v,
         width.n,
         prompt1.a
   uproc.a = "LookupArray.v"
   curtable.a = Table()
   curfield.a = Field()

   MoveTo table.a                    ;move to LookUpHelp table
   MoveTo FIELD field.a              ;to search on a specified field

   Home
   Canvas OFF
   width.n = 30
   IF SubStr(FieldType(),1,1) = "A" THEN
      width.n = NumVal(SubStr(FieldType(),2,3)) + 4
      width.n = Max(width.n,30)
      width.n = Min(width.n,72)
   ENDIF

   left.n = Int((79 - width.n)/2)
   IF Monitor() = "Color" THEN
      PaintCanvas ATTRIBUTE 8     7, left.n + 2, 22, left.n + width.n + 1
      Style ATTRIBUTE 47
   ELSE
      Style REVERSE
   ENDIF

   @  6,left.n ?? "" +Fill("",width.n-2)+ ""
   @ 21,left.n ?? "" +Fill("",width.n-2)+ ""
   a1 = "" +Fill(" ",width.n-2)+ ""
   a2 = "" +Fill("",width.n-2)+ ""
   @  7,left.n ?? a1
   @  8,left.n ?? a1
   @  9,left.n ?? a1
   @ 10,left.n ?? a1
   @ 11,left.n ?? a2

   prompt1.a = "Searching: " +Upper(Field())
   @ 7,Int((79-Len(prompt1.a))/2) ?? prompt1.a
   IF color.l THEN
      Style ATTRIBUTE 46
   ELSE
      Style REVERSE
   ENDIF
   @ 6,30 ?? "Incremental Search"
   @ 8,26 ?? "Highlight Record to Select"
   @ 9,26 ?? "Enter Characters to Locate"
   IF color.l THEN
      Style ATTRIBUTE 47
   ELSE
      Style INTENSE, REVERSE
   ENDIF

   WHILE CharWaiting()                 ; clear keyboard buffer
      retval = GetChar()               ; of any pending keystrokes
   ENDWHILE

   lastsearch.a = ""                   ; initialize keycode variable
   WHILE true                          ; LOOP TO TRAP KEYSTROKES:
      Canvas OFF
      @ 10,26 ?? "Searching For > " +Upper(lastsearch.a)+
                  Spaces(10 - Len(lastsearch.a))
      IF color.l THEN
         PaintCanvas ATTRIBUTE 32 10,26,10,40
         PaintCanvas ATTRIBUTE 10 10,41,10,52
      ELSE
         PaintCanvas REVERSE  10,41,10,52
      ENDIF
      next.n = LookupArrayMenu.a()     ;get next keycode value from keyboard
      SWITCH
         CASE next.n = 13              ; exit on [Enter] or [Esc] or [F2]
            OR next.n = 27
            OR next.n = -60   : QUITLOOP
         CASE next.n =  8:
            lastsearch.a = ""          ; loop on [BackSpace]
            Home                       ; to restart search
         OTHERWISE            :        ; concatenate symbols, then search
            IF Len(lastsearch.a) = 10 THEN
               Beep
               search.a = lastsearch.a
            ELSE
               search.a = lastsearch.a + Chr(next.n)
            ENDIF
            Locate NEXT PATTERN search.a + ".."
            lastsearch.a = search.a ; reset stored keycode values
      ENDSWITCH

   ENDWHILE                            ; END OF KEY TRAPPING LOOP

   IF next.n = 27 THEN             ; process [Esc] (cancel)
      v = false
   ELSE                                ; otherwise, [Enter]/[F2] (select)
      v = menu.r[Row()-11]
   ENDIF

   MoveTo curtable.a
   MoveTo FIELD curfield.a
   Return v

ENDPROC
WriteLib libname.a LookupArray.v
Release PROCS LookupArray.v
?? ""
; ===========================================================================
;       Title - LookupArrayMenu.a
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: 11/24/90 09:17:27pm    Revised:
; Description - Provides Windowed Menu for LocateArray and LookupArray
; ---------------------------------------------------------------------------
PROC LookupArrayMenu.a()
Private uproc.a,
        first.n,
        n,
        char.n
uproc.a = "LookupArrayMenu.a"
first.n = RecNo()                       ; store table record position
Array menu.r [9]                        ; array stores field values for menu
menu.r[1] = []                          ; assign field values as array elements

FOR n From 2 To 9                       ; display up to 9 values at once
    Skip 1
    IF EOT() THEN
        menu.r[n] = ""
    ELSE
        menu.r[n] = []
    ENDIF
ENDFOR

    FOR n From 12 To 20
        @ n,left.n ?? "" +Fill(" ",width.n-2)+ ""
    ENDFOR
    FOR n From 1 To 9                  ; display field values as menu choices
        @ n + 11,left.n + 2 ?? SubStr(StrVal(menu.r[n]),1,width.n-4)
    ENDFOR

MoveTo RECORD first.n                   ; return to original record
item.n = 1                              ; initialize bar-cursor position var.
While true                              ; LOOP TO DISPLAY POP-UP MENU:
    LookupArrayHilight.u()              ; highlight <current> selection
    char.n = GetChar()                  ; read character from keyboard
    SWITCH                              ; or ENTER,ESC,UP,DOWN,HOME,END
        CASE char.n >  31               ; Alphanumeric key ... send to call for
         AND char.n < 127   : QUITLOOP  ; use in LOCATE PATTERN command
        CASE char.n =  13               ; Enter... selection made
          OR char.n =  27               ; Esc  ... cancel
          OR char.n = -60   : QUITLOOP  ; [F2]
        CASE char.n = -72   : item.n = Mod(item.n + 7, 9) + 1   ; UP
        CASE char.n = -80   : item.n = Mod(item.n, 9) + 1       ; DOWN
        CASE char.n = -71   : item.n = 1    ; HOME
        CASE char.n = -79   : item.n = 9    ; END
        CASE char.n =   8   : QuitLoop      ; BACKSPACE - clear <search.a>, restart
        OTHERWISE           : Beep          ; Illegal keys
    ENDSWITCH
    Canvas OFF
ENDWHILE                             ;END OF LOOP TO DISPLAY MENU
Return char.n                          ;send PAL keycode back to call
ENDPROC
WriteLib libname.a LookupArrayMenu.a
Release PROCS LookupArrayMenu.a
?? ""
; ===========================================================================
;       Title - LookupArrayHilight.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: 11/24/90 09:18:37pm    Revised:
; Description - Highlights current item in LookupArrayMenu
; ---------------------------------------------------------------------------
PROC LookupArrayHilight.u()
Private  uproc.a
;Global  menu.r,
;        item.n,
;        left.n,
;        width.n
   uproc.a = "LookupArrayHilight.u"

   IF color.l THEN
      PaintCanvas ATTRIBUTE 47   12, left.n, 20, left.n + width.n - 1
      Style Attribute 10
   ELSE
      PaintCanvas REVERSE        12, left.n, 20, left.n + width.n - 1
      Style INTENSE
   ENDIF
   @ item.n + 11, left.n + 1
   ?? " " + StrVal(menu.r[item.n]) + Spaces(width.n - 4 - Len(menu.r[item.n]))
   Canvas ON
   Style
ENDPROC
WriteLib libname.a LookupArrayHilight.u
Release PROCS LookupArrayHilight.u
?? ""
; ===========================================================================
;       Title - LookupHelpKey.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;               Based upon a procedure by Zenreich/Kocis
;     Returns - No Value
;  Chronology - Created:
; Description - Routes [F1] to Lookup Table or context help as appropriate
; ---------------------------------------------------------------------------
PROC LookupHelpKey.u(context.a)
Private uproc.a
   uproc.a = "LookupHelpKey.a"
   Help                                    ; Check if there is assigned lookup help for this field.
   IF HelpMode() <> "LookupHelp" THEN
      Esc                                 ; Back to the main data table.
      HelpMenu.u(context.a)               ; context sensitive help
      Clear
      Return
   ENDIF

   WHILE true                              ; Now in the lookup table.
      Prompt " Selecting Lookup Value...    Search Using [Ctrl+Z] to Locate",
             " Press [F2] to Select    [Esc] to Cancel Lookup"
      LookupSelect.n()                    ; Lets user view and optionally select from table
      SWITCH
         CASE retval = -60   : Do_It!    ; Return to data table and fill in lookup value
         CASE retval = 27    : Esc       ; Return to data table without fill in
      ENDSWITCH
      QUITLOOP
   ENDWHILE
   Prompt                                  ; Cancel lookup prompt.
   Echo OFF
   Return
ENDPROC
WriteLib libname.a LookupHelpKey.u
Release PROCS LookupHelpKey.u
?? ""
; ===========================================================================
;       Title - LookupSelect.n
;      Author - (c) 1991 - Zenreich/Kocis
;     Returns - Keycode that ended Lookup
;  Revised By - Daniel J. Paolini II, CMA    Last Revised: 03-02-91 05:34pm
; Description - This allows you to simulate a Wait TABLE during Lookup Help.
;               It has been expanded to disable [Ctrl+O] , [Alt+O], and [F1],
;               and it also calls Zoom.l if necessary to trap for similar
;               keypresses while in Zoom.  Can't use in RUNTIME (Echo NORMAL).
; ---------------------------------------------------------------------------
PROC LookupSelect.n()                   ; adapted from DE ToolKit procedure
Private uproc.a
   uproc.a = "LookupSelect.n"
   Echo NORMAL             ;Display the table to the user.
   ImageRights READONLY    ;Prevent user from making changes to image.
   WHILE True
      retval = GetChar()
      SWITCH
         CASE MenuChoice() = "Error" ; Could be in HELP, HELP INDEX, or ZOOM.
            AND NOT IsFieldView()      ; don't want Esc in FieldView to exit lookup
            AND (retval =  -60         ; F2, Esc, CtrlBreak
            OR retval =   27
            OR retval =    0): QUITLOOP
         CASE (retval <  -60 AND retval > -71)
            OR  retval = -110
            OR  retval = -111
            OR  retval = -100
            OR  retval =   15
            OR retval  =   18
            OR  retval =  -24
            OR  retval =  -59
            OR  retval = -107
            OR  retval =  -45 : Beep
         CASE  retval =   26 : Zoom.l("FIRST") Echo NORMAL
         OTHERWISE           : KeyPress retval
      ENDSWITCH
   ENDWHILE
   Echo OFF
   SyncCursor
   IF retval = 0 THEN
      retval = 27                     ; [Ctrl+Break] functions as an [Esc].
   ENDIF                               ; from lookup help.
   ImageRights                         ; Restore image status of table.
   Return retval
ENDPROC
WriteLib libname.a LookupSelect.n
Release PROCS LookupSelect.n
?? ""
; ===========================================================================
;       TITLE: MainMenu.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-23-91 10:51:23pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MainMenu.l(items.n,status.n,himenu.n,lomenu.n,cursor.n)
Private  uproc.a, spot.r, item.n, key.n, loop.l
;Global  cfgtable.a,
;        condensed.a,                     ; Default Printer Condensed Setup
;        elite.a,                         ; Default Printer Elite Setup
;        hotkey.r,
;        hotproc.r,
;        mainmenu.r,                      ; Array of Main Menu choices
;        pica.a,                          ; Default Printer Pica Setup
;        port.a,                          ; Default Printer Port
;        proc.a,                          ; Name of current procedure
;        prompt.a,
   uproc.a = "MainMenu.l"

   Array spot.r[items.n]
   spot.r[1] = 2
   FOR n From 2 To items.n
      spot.r[n] = spot.r[n-1] + Len(mainmenu.r[n-1]) + 2
   ENDFOR
   item.n = 1                             ; Set "default" menu choice
   ClearAll

   WHILE true                             ; Loop 'til we droop
      Canvas OFF
      Clear
      IF ImageType() = "None" OR NOT Lower(Table()) = Lower(cfgtable.a) THEN
         ClearAll
         View cfgtable.a
         PickForm 1 + form.n              ; Menu "screen" Color or Mono
      ENDIF
      MoveTo [Main]                       ; Main Menu form page
      WHILE true                          ; Loop 'til we droop
         Echo NORMAL Echo OFF             ; Bring form to the Canvas
         @ 0,0 ?? "   " + Format("d5",Today()) +
                          Format("w56,ac",[App Title]) +
                          Upper(SubStr(Directory(),1,2)) +"  "+ SubStr(Time(),1,5)
         @ 1,0 ?? prompt.a
         IF color.l THEN
            PaintCanvas ATTRIBUTE himenu.n   0, 0, 1, 79  ; Top menu color
            PaintCanvas ATTRIBUTE status.n   0, 2, 0, 77  ; Status line color
            PaintCanvas ATTRIBUTE cursor.n   1,           ; Main Menu cursor color
                                             spot.r[item.n],
                                             1,
                                             spot.r[item.n] + Len(mainmenu.r[item.n]) + 1
         ELSE
            PaintCanvas REVERSE   0, 0, 1, 79  ; Top menu color
            PaintCanvas INTENSE   0, 2, 0, 77  ; Status line color
            PaintCanvas INTENSE   1,           ; Main Menu cursor color
                                  spot.r[item.n],
                                  1,
                                  spot.r[item.n] + Len(mainmenu.r[item.n]) + 1
         ENDIF
         Canvas ON                        ; Lights!
         key.n = GetChar()                ; Camera!
         SWITCH                           ; Action!
            CASE key.n = hotkey.r[1]:     ; Up to three application hot-keys
               ExecProc hotproc.r[1]
            CASE key.n = hotkey.r[2]:
               ExecProc hotproc.r[2]
            CASE key.n = hotkey.r[3]:
               ExecProc hotproc.r[3]
            CASE key.n > 32
             AND key.n < 127        :     ; Alphnumeric keys
               FOR n From 1 To items.n    ; Search for Menu Item
                  l = false
                  IF Upper(SubStr(mainmenu.r[n],1,1)) = Upper(Chr(key.n)) THEN
                     item.n = n
                     l = true
                     QUITLOOP
                  ENDIF
               ENDFOR
               IF l THEN
                  QUITLOOP
               ENDIF
               Beep
            CASE key.n = -60              ; F2
              OR key.n =  13              ; Enter
              OR key.n = -80        :     ; Down
               QUITLOOP
            CASE key.n =  27        :     ; Esc
               item.n = items.n
            CASE key.n = -59
              OR key.n = -35        :     ; F1, Alt+H
               HelpMenu.u(mainmenu.r[item.n])
            CASE key.n = -75        :
               IF item.n = 1 THEN         ; If at first, wrap to last
                  item.n = items.n
               ELSE
                  item.n = item.n - 1
               ENDIF
            CASE key.n = -77        :
               IF item.n = items.n THEN   ; If at last, scroll to first
                  item.n = 1
               ELSE
                  item.n = item.n + 1
               ENDIF
            OTHERWISE : Beep              ; Illegal Key
         ENDSWITCH
         Canvas OFF                       ; Hide re-painting
         Clear
      ENDWHILE
; ---------------------------------------------------------------------------
; By naming the sub-procedures based upon the menu choices, you can use the
;   ExecProc [menuchoice] + ".u" code to eliminate quite a few lines of code
;   in the SWITCH statement.  Contrary to popular belief, EXECPROC does not
;   inhibit proc swapping.
; ---------------------------------------------------------------------------
      execproc.a = "Main" +mainmenu.r[item.n]+ ".u"   ; Procedure to call
      WHILE true
         loop.l = false                   ; Initialize DropDown Loop variable
         ExecProc execproc.a              ; Call selected Proc
         IF execproc.a = "EXIT" THEN      ; QUIT was confirmed
            Return true
         ENDIF
         IF NOT loop.l OR execproc.a = "RETURN" THEN  ; Return to Main Menu
            SetSwap Int(swap.n/2)
            QUITLOOP
         ENDIF
         key.n = 0                        ; Used by procs without submenus
         IF ImageType() = "None" OR NOT Lower(Table()) = Lower(cfgtable.a) THEN
            ClearAll
            View cfgtable.a
            PickForm 1 + form.n              ; Menu "screen" Color or Mono
         ENDIF
      ENDWHILE
   ENDWHILE
ENDPROC
WriteLib libname.a MainMenu.l
Release PROCS      MainMenu.l
?? ""
; ===========================================================================
;       TITLE: MainQuit.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 03:43:14pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION: Generic QUIT DropDown menu module
; ---------------------------------------------------------------------------
PROC MainQuit.u()
Private  item.r,                          ; Array of Dropdown Menu Items
         uproc.a,                         ; Name of current procedure
         proc.r                          ; Array of Procedures to Call

   proc.a = "MainQuit.u"
   IF item.n = 0 THEN
      Return
   ENDIF

   MoveTo [Quit]
   Array item.r[2]   Array proc.r[2]
      item.r[1]   = "YES - Quit this Application"
      proc.r[1]   = "EXIT"
      item.r[2]   = "NO  - Do NOT Quit, Continue"
      proc.r[2]   = "RETURN"
   execproc.a = MenuPull.u(spot.r[item.n],30,79)
   Return
ENDPROC
WriteLib libname.a MainQuit.u
Release PROCS      MainQuit.u
?? ""
; ===========================================================================
;       TITLE: MenuPop.n
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-21-91 08:46:52am     Last Revised:
;     RETURNS:
; DESCRIPTION: Popup Multi-item Menu
; ---------------------------------------------------------------------------
PROC MenuPop.n(top.n,                  ; Top row
               left.n,                 ; Left column
               title.a,                ; Menu Title
               box.n,                  ; Menu color
               choices.n,              ; Choices color
               cursor.n)               ; Cursor color
Private  length.n,
         choice.n,                     ; Current Menu item number
         items.n,
         prompt1.a,
         right.n,
         row.n,
         key.n,
         format1.a,
         format2.a,
         n,
         uproc.a                          ; Name of current procedure
;Global  popitems.r
   uproc.a  = "MenuPop.n"
   items.n = ArraySize(popitems.r)
   choice.n = Len(popitems.r[1])
   IF items.n > 1 THEN
      FOR n From 2 To items.n
         choice.n = Max(choice.n,Len(popitems.r[n]))
      ENDFOR
   ENDIF

   length.n = Max(Len(title.a)+2,choice.n+2)
   IF (left.n + length.n + 3) > 79 THEN
      left.n = 79 - length.n - 3
   ENDIF

   right.n   = left.n + length.n + 1
   Canvas OFF
   @ top.n,left.n    ?? "" +Fill("",length.n)+ ""
   @ top.n+1,left.n  ?? "" +Format("w" +StrVal(length.n)+ ",ac",title.a)
   @ top.n+1,right.n ?? ""
   @ top.n+2,left.n  ?? "" +Fill("",length.n)+ ""
   @ top.n+3+items.n,left.n  ?? "" +Fill("",length.n)+ ""

   FOR n From 1 To items.n
      @ top.n+2+n,left.n  ?? "" +" "+ popitems.r[n]+
                                 Spaces(choice.n-Len(popitems.r[n])+4)
      @ top.n+2+n,right.n ?? ""
   ENDFOR

   IF color.l THEN
      PaintCanvas ATTRIBUTE box.n      top.n, left.n, top.n+3+items.n, right.n
      PaintCanvas ATTRIBUTE choices.n  top.n+1, left.n+1, top.n+1, right.n-1
      PaintCanvas ATTRIBUTE 8          top.n+1, left.n+length.n+2,
                                       top.n+3+items.n, right.n+2
      PaintCanvas ATTRIBUTE 8          top.n+4+items.n, left.n+2,
                                       top.n+4+items.n, right.n+2
   ELSE
      PaintCanvas REVERSE     top.n, left.n, top.n+3+items.n, right.n
   ENDIF

   row.n     = 1
   WHILE true
      IF color.l THEN
         PaintCanvas ATTRIBUTE choices.n  top.n+3, left.n+1, top.n+2+items.n, left.n+choice.n+2
         PaintCanvas ATTRIBUTE cursor.n   top.n+2+row.n, left.n+1,
                                          top.n+2+row.n, left.n+2+choice.n
      ELSE
         PaintCanvas REVERSE     top.n+3, left.n+1, top.n+2+items.n, left.n+choice.n+2
         PaintCanvas INTENSE     top.n+2+row.n, left.n+1,
                                 top.n+2+row.n, left.n+2+choice.n
      ENDIF
      Canvas ON
      key.n = GetChar()
      SWITCH
         CASE key.n = -59
           OR key.n = -35        : Return 99    ; 99 Means Helpkey pressed
         CASE key.n > 32
          AND key.n < 127        :     ; Alphnumeric keys
            FOR n From 1 To items.n    ; Search for Menu Item
               IF Upper(SubStr(popitems.r[n],1,1)) = Upper(Chr(key.n)) THEN
                  Return n
               ENDIF
            ENDFOR
            Beep
         CASE key.n = -72 :           ; Up
            IF row.n = 1 THEN
               row.n = items.n
            ELSE
               row.n = row.n - 1
            ENDIF
         CASE key.n = -80 :           ; Down
            IF row.n = items.n THEN
               row.n = 1
            ELSE
               row.n = row.n + 1
            ENDIF
         CASE key.n = 27   : Return 0
         CASE key.n = 13   : Return row.n
         OTHERWISE         : Beep
      ENDSWITCH
      Canvas OFF
   ENDWHILE
ENDPROC
WriteLib libname.a MenuPop.n
Release PROCS      MenuPop.n
?? ""
; ===========================================================================
;       TITLE: MenuPop2.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-21-91 08:46:52am     Last Revised:
;     RETURNS: Logical true/false based upon selection
; DESCRIPTION: Confirmation Menu
; ---------------------------------------------------------------------------
PROC MenuPop2.l(top.n,                 ; Top row
                left.n,                ; Left column
                title.a,               ; Menu Title
                choice1.a,             ; 1st choice
                choice2.a,             ; 2nd choice
                prompt1.a,             ; 1st prompt
                prompt2.a,             ; 2nd prompt
                box.n,                 ; Menu color
                choices.n,             ; Choices color
                cursor.n,              ; Cursor color
                first.l)               ; Is 1st choice true
Private  length.n,
         choice.n,
         prompt.a,
         right.n,
         row.n,
         key.n,
         format1.a,
         format2.a,
         uproc.a                          ; Name of current procedure
   uproc.a  = "MenuPop2.l"

   choice.n = Max(Len(choice1.a),Len(choice2.a))
   length.n = Max(Len(title.a)+2,choice.n+Max(Len(prompt1.a),Len(prompt2.a))+4)
   IF (left.n + length.n + 3) > 79 THEN
      left.n = 79 - length.n - 3
   ENDIF

   right.n   = left.n + length.n + 1
   row.n     = top.n+3
   Canvas OFF
   @ top.n,left.n    ?? "" +Fill("",length.n)+ ""
   @ top.n+1,left.n  ?? "" +Format("w" +StrVal(length.n)+ ",ac",title.a)
   @ top.n+2,left.n  ?? "" +Fill("",length.n)+ ""
   @ top.n+3,left.n  ?? "" +" "+ choice1.a +Spaces(choice.n-Len(choice1.a)+2)+
                                  Format("w" +StrVal(length.n-choice.n-3)+ ",al",prompt1.a)
   @ top.n+4,left.n  ?? "" +" "+ choice2.a +Spaces(choice.n-Len(choice2.a)+2)+
                                  Format("w" +StrVal(length.n-choice.n-3)+ ",al",prompt2.a)
   @ top.n+5,left.n  ?? "" +Fill("",length.n)+ ""
   @ top.n+1,right.n ?? ""
   @ top.n+3,right.n ?? ""
   @ top.n+4,right.n ?? ""

   IF color.l THEN
      PaintCanvas ATTRIBUTE box.n      top.n, left.n, top.n+5, right.n
      PaintCanvas ATTRIBUTE choices.n  top.n+1, left.n+1, top.n+1, right.n-1
      PaintCanvas ATTRIBUTE 8          top.n+1, left.n+length.n+2, top.n+5, right.n+2
      PaintCanvas ATTRIBUTE 8          top.n+6, left.n+2, top.n+6, right.n+2
   ELSE
      PaintCanvas REVERSE     top.n, left.n, top.n+5, right.n
   ENDIF

   WHILE true
      IF color.l THEN
         PaintCanvas ATTRIBUTE choices.n  top.n+3, left.n+1, top.n+4, left.n+choice.n+2
         PaintCanvas ATTRIBUTE cursor.n   row.n, left.n+1, row.n, left.n+2+choice.n
      ELSE
         PaintCanvas REVERSE     top.n+3, left.n+1, top.n+4, left.n+choice.n+2
         PaintCanvas INTENSE     row.n, left.n+1, row.n, left.n+2+choice.n
      ENDIF
      Canvas ON
      key.n = GetChar()
      SWITCH
         CASE key.n > 32
          AND key.n < 127        :     ; Alphnumeric keys
            IF Upper(SubStr(choice1.a,1,1)) = Upper(Chr(key.n)) THEN
               Return first.l
            ENDIF
            IF Upper(SubStr(choice2.a,1,1)) = Upper(Chr(key.n)) THEN
               Return NOT first.l
            ENDIF
            Beep
         CASE key.n = -72
           OR key.n = -80 :
            IF row.n = top.n + 3 THEN
               row.n = top.n + 4
            ELSE
               row.n = top.n + 3
            ENDIF
         CASE key.n = 27  : Return false
         CASE (choice1.a = "DO-IT!" OR choice2.a = "DO-IT!")
          AND key.n = -60 : Return true
         CASE row.n = (top.n + 3)
          AND key.n = 13  : Return first.l
         CASE row.n = (top.n + 4)
          AND key.n = 13  : Return NOT first.l
         OTHERWISE         : Beep
      ENDSWITCH
      Canvas OFF
   ENDWHILE
ENDPROC
WriteLib libname.a MenuPop2.l
Release PROCS      MenuPop2.l
?? ""
; ===========================================================================
;       TITLE: MenuPull.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 01:20:40pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MenuPull.u(col.n,menuatt.n,cursatt.n)
Private  uproc.a,                         ; Name of current procedure
         key.n,                           ; Key pressed
         n,                               ; Counter
         items.n,                         ; Number of items in Dropdown Menu
         row.n,                           ; Row counter for Dropdown Menu
         length.n                         ; Length of Menu Box
;Global  proc.r                           ; Array of Procedures to call
;        item.n                           ; Which Master Menu item #
;        loop.l                           ; Stay in DropDown Menus?
;        prompt.a
;        himenu.n
;        lomenu.n
;        cursor.n
;        status.n
;        item.r
   uproc.a = "MenuPull.u"
   IF item.n = 0 THEN                     ; Just Read into Memory
      Return
   ENDIF

   IF NOT color.l THEN
      menuatt.n = 15
      cursatt.n = 112
   ENDIF

   row.n = 1
   items.n = ArraySize(item.r)
   length.n = Len(mainmenu.r[item.n]) + 2

   FOR n From 1 To items.n
      length.n = Max(length.n,Len(item.r[n])+2)
   ENDFOR
   IF col.n + length.n > 78 THEN
      col.n = 78 - length.n
   ENDIF

WHILE true
   Canvas OFF
   Clear
   Echo NORMAL Echo OFF                   ; Update Canvas
   @ 0,0 ?? "   " + Format("d5",Today()) +
                    Format("w56,ac",[App Title]) +
                    Upper(SubStr(Directory(),1,2)) +"  "+ SubStr(Time(),1,5)
   @ 1,0 ?? prompt.a
   IF color.l THEN
      PaintCanvas ATTRIBUTE lomenu.n   0, 0, 1, 79
      PaintCanvas ATTRIBUTE cursor.n   1, spot.r[item.n], 1,
                                          spot.r[item.n] + Len(mainmenu.r[item.n]) + 1
   ELSE
      PaintCanvas REVERSE   0, 0, 1, 79
      PaintCanvas INTENSE   1, spot.r[item.n], 1,
                               spot.r[item.n] + Len(mainmenu.r[item.n]) + 1
   ENDIF

   @ 2,col.n ?? Spaces(length.n)
   FOR n From 1 to items.n
      @ n+2,col.n ?? " " + item.r[n] + Spaces(length.n-Len(item.r[n])-1)
   ENDFOR
   @ 3+items.n,col.n ?? Spaces(length.n)

   IF color.l THEN
      PaintCanvas ATTRIBUTE 8  3, col.n+length.n, 3+items.n, col.n+length.n+1
      PaintCanvas ATTRIBUTE 8  4+items.n, col.n+2, 4+items.n, col.n+length.n+1
   ENDIF

   WHILE true
      @ 0,72 ?? SubStr(Time(),1,5)
      IF color.l THEN
         PaintCanvas ATTRIBUTE status.n   0,2,0,77
         PaintCanvas ATTRIBUTE menuatt.n  2, col.n, 3+items.n, col.n+length.n-1
         PaintCanvas ATTRIBUTE cursatt.n  row.n+2,
                                          col.n,
                                          row.n+2,
                                          Len(item.r[row.n])+col.n+1
      ELSE
         PaintCanvas INTENSE  0,2,0,77
         PaintCanvas INTENSE  2, col.n, 3+items.n, col.n+length.n-1
         PaintCanvas REVERSE  row.n+2,
                              col.n,
                              row.n+2,
                              Len(item.r[row.n])+col.n+1
      ENDIF
      Canvas ON
      key.n = GetChar()
      SWITCH
         CASE key.n > 32
          AND key.n < 127       :
            FOR n From 1 To ArraySize(item.r)
               IF Upper(SubStr(item.r[n],1,1)) = Upper(Chr(key.n)) THEN
                  loop.l = true                 ; Stay in DropDown module
                  Return proc.r[n]
               ENDIF
            ENDFOR
            Beep
         CASE key.n = -60
           OR key.n =  13       :
            loop.l = true                 ; Stay in DropDown module
            Return proc.r[row.n]
         CASE key.n =  27
           OR key.n = -68       :
            Return "RETURN"
         CASE key.n = -59
           OR key.n = -35       :
            HelpMenu.u(mainmenu.r[item.n])
            QUITLOOP
         CASE key.n = -75       :
            IF item.n = 1 THEN
               item.n = ArraySize(mainmenu.r)
            ELSE
               item.n = item.n - 1
            ENDIF
            loop.l = true
            Return "Main" +mainmenu.r[item.n]+ ".u"
         CASE key.n = -77       :
            IF item.n = ArraySize(mainmenu.r) THEN
               item.n = 1
            ELSE
               item.n = item.n + 1
            ENDIF
            loop.l = true
            Return "Main" +mainmenu.r[item.n]+ ".u"
         CASE key.n = -72       :        ; Up
            IF row.n = 1 THEN
               row.n = ArraySize(item.r)
            ELSE
               row.n = row.n - 1
            ENDIF
         CASE key.n = -80       :        ; Down
            IF row.n = ArraySize(item.r) THEN
               row.n = 1
            ELSE
               row.n = row.n + 1
            ENDIF
         OTHERWISE               : Beep             ; Illegal Key
      ENDSWITCH
      Canvas OFF
   ENDWHILE
ENDWHILE
ENDPROC
WriteLib libname.a MenuPull.u
Release PROCS      MenuPull.u
?? ""
